/* A Bison parser, made by GNU Bison 1.875.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     IDENTIFIER = 258,
     SYMBOL = 259,
     ARRAY_SYMBOL = 260,
     TYPE_FLOAT = 261,
     TYPE_POINT = 262,
     TYPE_STRING = 263,
     TYPE_COLOR = 264,
     TYPE_NORMAL = 265,
     TYPE_VECTOR = 266,
     TYPE_VOID = 267,
     TYPE_MATRIX = 268,
     TYPE_UNIFORM = 269,
     TYPE_VARYING = 270,
     SHADER_TYPE_SURFACE = 271,
     SHADER_TYPE_VOLUME = 272,
     SHADER_TYPE_IMAGER = 273,
     SHADER_TYPE_TRANSFORMATION = 274,
     SHADER_TYPE_DISPLACEMENT = 275,
     SHADER_TYPE_LIGHT = 276,
     SHADER_TYPE_ATMOSPHERE = 277,
     ATTRIBUTE = 278,
     OPTION = 279,
     RENDERERINFO = 280,
     INCIDENT = 281,
     OPPOSITE = 282,
     LIGHTSOURCE = 283,
     EXTERN = 284,
     TEXTUREINFO = 285,
     OUTPUT = 286,
     IF = 287,
     ELSE = 288,
     WHILE = 289,
     FOR = 290,
     CONTINUE = 291,
     BREAK = 292,
     RETURN = 293,
     ILLUMINATE = 294,
     ILLUMINANCE = 295,
     SOLAR = 296,
     TEXTUREMAP = 297,
     ENVIRONMENT = 298,
     BUMP = 299,
     SHADOW = 300,
     OCCLUSION = 301,
     SETXCOMP = 302,
     SETYCOMP = 303,
     SETZCOMP = 304,
     SETCOMP = 305,
     DIV_ASSIGN = 306,
     MUL_ASSIGN = 307,
     SUB_ASSIGN = 308,
     ADD_ASSIGN = 309,
     OR_OP = 310,
     AND_OP = 311,
     NE_OP = 312,
     EQ_OP = 313,
     LE_OP = 314,
     GE_OP = 315,
     NEG = 316,
     FLOAT_CONSTANT = 317,
     STRING_LITERAL = 318
   };
#endif
#define IDENTIFIER 258
#define SYMBOL 259
#define ARRAY_SYMBOL 260
#define TYPE_FLOAT 261
#define TYPE_POINT 262
#define TYPE_STRING 263
#define TYPE_COLOR 264
#define TYPE_NORMAL 265
#define TYPE_VECTOR 266
#define TYPE_VOID 267
#define TYPE_MATRIX 268
#define TYPE_UNIFORM 269
#define TYPE_VARYING 270
#define SHADER_TYPE_SURFACE 271
#define SHADER_TYPE_VOLUME 272
#define SHADER_TYPE_IMAGER 273
#define SHADER_TYPE_TRANSFORMATION 274
#define SHADER_TYPE_DISPLACEMENT 275
#define SHADER_TYPE_LIGHT 276
#define SHADER_TYPE_ATMOSPHERE 277
#define ATTRIBUTE 278
#define OPTION 279
#define RENDERERINFO 280
#define INCIDENT 281
#define OPPOSITE 282
#define LIGHTSOURCE 283
#define EXTERN 284
#define TEXTUREINFO 285
#define OUTPUT 286
#define IF 287
#define ELSE 288
#define WHILE 289
#define FOR 290
#define CONTINUE 291
#define BREAK 292
#define RETURN 293
#define ILLUMINATE 294
#define ILLUMINANCE 295
#define SOLAR 296
#define TEXTUREMAP 297
#define ENVIRONMENT 298
#define BUMP 299
#define SHADOW 300
#define OCCLUSION 301
#define SETXCOMP 302
#define SETYCOMP 303
#define SETZCOMP 304
#define SETCOMP 305
#define DIV_ASSIGN 306
#define MUL_ASSIGN 307
#define SUB_ASSIGN 308
#define ADD_ASSIGN 309
#define OR_OP 310
#define AND_OP 311
#define NE_OP 312
#define EQ_OP 313
#define LE_OP 314
#define GE_OP 315
#define NEG 316
#define FLOAT_CONSTANT 317
#define STRING_LITERAL 318




/* Copy the first part of user declarations.  */
#line 5 "parser.yxx"

#ifdef	WIN32
#include <malloc.h>
#pragma warning(disable : 4786)
#include <cstdio>
#include <memory>
namespace std
{ using ::size_t; 
  using ::malloc;
  using ::free;
}
#endif

#include <algorithm>
#include <iostream>
#include <map>
#include <string>
#include <vector>
#include <cassert>

#include	"parsenode.h"
#include	"logging.h"

# define YYMAXDEPTH 100000
# define YYINITDEPTH  2000

using namespace Aqsis;


namespace Aqsis
{

extern CqString ParseStreamName;
extern std::ostream* ParseErrorStream;
extern TqInt ParseLineNumber;
extern TqBool ParseSucceeded;
extern TqInt	iArrayAccess;
CqParseNode*	ParseTreePointer;
std::vector<CqString>	ParseNameSpaceStack;
std::vector<TqInt>		FunctionReturnCountStack;
EqShaderType gShaderType;

TqBool	FindVariable(const char* name, SqVarRef& ref);
TqBool	FindFunction(const char* name, std::vector<SqFuncRef>& Ref);
CqString strNameSpace();
void	TypeCheck();
void	Optimise();
void	InitStandardNamespace();
void	ProcessShaderArguments( CqParseNode* pArgs );

}



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 60 "parser.yxx"
typedef union YYSTYPE {
	CqParseNode*	m_pParseNode;
	TqInt			m_VarType;
	EqShaderType	m_ShaderType;
	TqFloat			m_FloatConst;
	CqString*	m_Identifier;
	struct{
		SqVarRef		VarRef;
		SqFuncRef		FuncRef;
		TqInt				eType;
	}				m_pSymbol;
	struct{
		TqInt				Type;
		CqString*	Space;
	}				m_TypeAndSpace;
	EqCommType		m_CommType;
} YYSTYPE;
/* Line 191 of yacc.c.  */
#line 273 "y.tab.c"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */
#line 78 "parser.yxx"

extern TqInt yylex();
static void yyerror(const CqString Message);


/* Line 214 of yacc.c.  */
#line 289 "y.tab.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  41
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   2258

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  84
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  46
/* YYNRULES -- Number of rules. */
#define YYNRULES  179
/* YYNRULES -- Number of states. */
#define YYNSTATES  388

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   318

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    72,     2,     2,     2,     2,     2,     2,
      74,    75,    70,    66,    81,    67,    71,    69,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    57,    80,
      61,    51,    60,    56,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    82,     2,    83,    68,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    78,     2,    79,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    52,    53,    54,    55,
      58,    59,    62,    63,    64,    65,    73,    76,    77
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short yyprhs[] =
{
       0,     0,     3,     5,     8,    10,    12,    21,    30,    38,
      46,    53,    59,    63,    66,    70,    73,    75,    77,    79,
      81,    83,    85,    87,    91,    94,    97,   101,   104,   108,
     111,   113,   115,   119,   122,   124,   129,   135,   139,   142,
     144,   149,   155,   159,   162,   167,   169,   173,   175,   177,
     179,   181,   183,   185,   187,   189,   191,   193,   196,   198,
     201,   203,   206,   208,   211,   213,   216,   218,   220,   222,
     225,   228,   231,   234,   237,   241,   244,   246,   249,   251,
     255,   258,   260,   264,   268,   274,   280,   284,   288,   298,
     308,   313,   321,   327,   337,   343,   351,   361,   373,   376,
     378,   380,   382,   384,   388,   392,   396,   400,   404,   408,
     411,   413,   419,   422,   424,   426,   428,   433,   435,   437,
     439,   441,   443,   447,   455,   489,   491,   493,   495,   497,
     499,   501,   505,   509,   513,   517,   520,   524,   528,   532,
     536,   540,   547,   554,   561,   568,   575,   580,   584,   589,
     593,   595,   599,   606,   612,   618,   623,   625,   627,   629,
     631,   633,   635,   639,   642,   646,   648,   650,   652,   654,
     656,   658,   660,   662,   664,   666,   668,   675,   684,   691
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const short yyrhs[] =
{
      85,     0,    -1,    86,    -1,    85,    86,    -1,    87,    -1,
      88,    -1,    90,     3,    74,    91,    75,    78,   108,    79,
      -1,    90,     4,    74,    91,    75,    78,   108,    79,    -1,
      90,     3,    74,    75,    78,   108,    79,    -1,    90,     4,
      74,    75,    78,   108,    79,    -1,    89,    91,    75,    78,
     108,    79,    -1,    89,    75,    78,   108,    79,    -1,    94,
       3,    74,    -1,     3,    74,    -1,    94,     4,    74,    -1,
       4,    74,    -1,    21,    -1,    16,    -1,    17,    -1,    20,
      -1,    19,    -1,    18,    -1,    92,    -1,    91,    80,    92,
      -1,    91,    80,    -1,    94,    95,    -1,    31,    94,    95,
      -1,    94,    95,    -1,    29,    94,    95,    -1,   100,   101,
      -1,   101,    -1,    96,    -1,    95,    81,    96,    -1,     3,
      97,    -1,     3,    -1,     3,    82,   127,    83,    -1,     3,
      82,   127,    83,    98,    -1,     3,    82,    83,    -1,     4,
      97,    -1,     4,    -1,     4,    82,   127,    83,    -1,     4,
      82,   127,    83,    98,    -1,     4,    82,    83,    -1,    51,
     113,    -1,    51,    78,    99,    79,    -1,   113,    -1,    99,
      81,   113,    -1,    15,    -1,    14,    -1,     6,    -1,     8,
      -1,    12,    -1,   102,    -1,   103,    -1,   104,    -1,   105,
      -1,   106,    -1,     7,   107,    -1,     7,    -1,     9,   107,
      -1,     9,    -1,    11,   107,    -1,    11,    -1,    10,   107,
      -1,    10,    -1,    13,   107,    -1,    13,    -1,    77,    -1,
     109,    -1,   108,   109,    -1,   118,    80,    -1,   119,    80,
      -1,   120,    80,    -1,   129,    80,    -1,    38,   113,    80,
      -1,   111,    80,    -1,   110,    -1,    93,    80,    -1,    88,
      -1,    78,   108,    79,    -1,    78,    79,    -1,    80,    -1,
      32,   117,   109,    -1,    32,   113,   109,    -1,    32,   117,
     109,    33,   109,    -1,    32,   113,   109,    33,   109,    -1,
      34,   117,   109,    -1,    34,   113,   109,    -1,    35,    74,
     113,    80,   117,    80,   113,    75,   109,    -1,    35,    74,
     113,    80,   113,    80,   113,    75,   109,    -1,    41,    74,
      75,   109,    -1,    41,    74,   113,    81,   113,    75,   109,
      -1,    39,    74,   113,    75,   109,    -1,    39,    74,   113,
      81,   113,    81,   113,    75,   109,    -1,    40,    74,   113,
      75,   109,    -1,    40,    74,   113,    81,   113,    75,   109,
      -1,    40,    74,   113,    81,   113,    81,   113,    75,   109,
      -1,    40,    74,   113,    81,   113,    81,   113,    81,   113,
      75,   109,    -1,   112,   127,    -1,   112,    -1,    37,    -1,
      36,    -1,   115,    -1,   113,    71,   113,    -1,   113,    69,
     113,    -1,   113,    70,   113,    -1,   113,    68,   113,    -1,
     113,    66,   113,    -1,   113,    67,   113,    -1,    67,   113,
      -1,   114,    -1,   117,    56,   113,    57,   113,    -1,   101,
     113,    -1,   127,    -1,   122,    -1,     4,    -1,     5,    82,
     113,    83,    -1,    77,    -1,   119,    -1,   120,    -1,   129,
      -1,   118,    -1,    74,   113,    75,    -1,    74,   113,    81,
     113,    81,   113,    75,    -1,    74,   113,    81,   113,    81,
     113,    81,   113,    81,   113,    81,   113,    81,   113,    81,
     113,    81,   113,    81,   113,    81,   113,    81,   113,    81,
     113,    81,   113,    81,   113,    81,   113,    75,    -1,    60,
      -1,    65,    -1,    61,    -1,    64,    -1,    63,    -1,    62,
      -1,    74,   117,    75,    -1,   113,   116,   113,    -1,   117,
      59,   117,    -1,   117,    58,   117,    -1,    72,   117,    -1,
       4,    51,   113,    -1,     4,    55,   113,    -1,     4,    54,
     113,    -1,     4,    53,   113,    -1,     4,    52,   113,    -1,
       5,    82,   113,    83,    51,   113,    -1,     5,    82,   113,
      83,    55,   113,    -1,     5,    82,   113,    83,    54,   113,
      -1,     5,    82,   113,    83,    53,   113,    -1,     5,    82,
     113,    83,    52,   113,    -1,     4,    74,   121,    75,    -1,
       4,    74,    75,    -1,     3,    74,   121,    75,    -1,     3,
      74,    75,    -1,   113,    -1,   121,    81,   113,    -1,   123,
      74,   124,   125,   126,    75,    -1,   123,    74,   124,   126,
      75,    -1,   123,    74,   124,   125,    75,    -1,   123,    74,
     124,    75,    -1,    42,    -1,    43,    -1,    44,    -1,    45,
      -1,    46,    -1,   113,    -1,    82,   113,    83,    -1,    81,
     113,    -1,   126,    81,   113,    -1,    76,    -1,    22,    -1,
      20,    -1,    28,    -1,    16,    -1,    23,    -1,    24,    -1,
      25,    -1,    26,    -1,    27,    -1,    30,    -1,   128,    74,
     113,    81,     4,    75,    -1,   128,    74,   113,    81,   113,
      81,     4,    75,    -1,   128,    74,   113,    81,     5,    75,
      -1,   128,    74,   113,    81,   113,    81,     5,    75,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short yyrline[] =
{
       0,   167,   167,   168,   173,   174,   178,   191,   207,   214,
     227,   266,   289,   297,   305,   318,   334,   337,   340,   343,
     346,   349,   355,   368,   379,   383,   454,   530,   605,   656,
     660,   664,   670,   678,   687,   694,   701,   710,   717,   731,
     741,   751,   763,   776,   782,   797,   803,   811,   812,   816,
     820,   824,   828,   829,   830,   831,   832,   836,   840,   847,
     851,   858,   862,   869,   873,   880,   884,   891,   895,   901,
     909,   910,   918,   926,   931,   940,   941,   942,   968,   969,
     970,   971,   972,   980,   994,  1003,  1022,  1028,  1041,  1056,
    1078,  1084,  1098,  1107,  1123,  1136,  1150,  1167,  1188,  1189,
    1193,  1197,  1205,  1206,  1217,  1228,  1239,  1250,  1261,  1272,
    1282,  1283,  1296,  1342,  1346,  1347,  1351,  1356,  1360,  1361,
    1362,  1363,  1364,  1367,  1375,  1399,  1400,  1401,  1402,  1403,
    1404,  1408,  1411,  1418,  1425,  1432,  1440,  1446,  1460,  1474,
    1488,  1502,  1509,  1527,  1545,  1563,  1584,  1594,  1605,  1627,
    1643,  1649,  1657,  1671,  1685,  1691,  1700,  1706,  1712,  1718,
    1724,  1733,  1740,  1744,  1750,  1759,  1764,  1765,  1766,  1767,
    1768,  1769,  1770,  1771,  1772,  1773,  1778,  1799,  1829,  1850
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "IDENTIFIER", "SYMBOL", "ARRAY_SYMBOL", 
  "TYPE_FLOAT", "TYPE_POINT", "TYPE_STRING", "TYPE_COLOR", "TYPE_NORMAL", 
  "TYPE_VECTOR", "TYPE_VOID", "TYPE_MATRIX", "TYPE_UNIFORM", 
  "TYPE_VARYING", "SHADER_TYPE_SURFACE", "SHADER_TYPE_VOLUME", 
  "SHADER_TYPE_IMAGER", "SHADER_TYPE_TRANSFORMATION", 
  "SHADER_TYPE_DISPLACEMENT", "SHADER_TYPE_LIGHT", 
  "SHADER_TYPE_ATMOSPHERE", "ATTRIBUTE", "OPTION", "RENDERERINFO", 
  "INCIDENT", "OPPOSITE", "LIGHTSOURCE", "EXTERN", "TEXTUREINFO", 
  "OUTPUT", "IF", "ELSE", "WHILE", "FOR", "CONTINUE", "BREAK", "RETURN", 
  "ILLUMINATE", "ILLUMINANCE", "SOLAR", "TEXTUREMAP", "ENVIRONMENT", 
  "BUMP", "SHADOW", "OCCLUSION", "SETXCOMP", "SETYCOMP", "SETZCOMP", 
  "SETCOMP", "'='", "DIV_ASSIGN", "MUL_ASSIGN", "SUB_ASSIGN", 
  "ADD_ASSIGN", "'?'", "':'", "OR_OP", "AND_OP", "'>'", "'<'", "NE_OP", 
  "EQ_OP", "LE_OP", "GE_OP", "'+'", "'-'", "'^'", "'/'", "'*'", "'.'", 
  "'!'", "NEG", "'('", "')'", "FLOAT_CONSTANT", "STRING_LITERAL", "'{'", 
  "'}'", "';'", "','", "'['", "']'", "$accept", "file", "definitions", 
  "shader_definition", "function_definition", "function_declaration", 
  "shader_type", "formals", "formal_variable_definitions", 
  "variable_definitions", "typespec", "def_expressions", "def_expression", 
  "def_init", "def_array_initialisers", "array_initialisers", "detail", 
  "type", "pspace", "cspace", "vspace", "nspace", "mspace", "spacetype", 
  "statements", "statement", "loop_control", "loop_modstmt", "loop_mod", 
  "expression", "cast_expr", "primary", "relational_operator", "relation", 
  "assignexpression", "procedurecall", "unresolvedcall", "proc_arguments", 
  "texture", "texture_type", "texture_filename", "channel", 
  "texture_arguments", "number", "comm_type", "comm_function", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,    61,   306,   307,   308,   309,    63,    58,   310,   311,
      62,    60,   312,   313,   314,   315,    43,    45,    94,    47,
      42,    46,    33,   316,    40,    41,   317,   318,   123,   125,
      59,    44,    91,    93
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    84,    85,    85,    86,    86,    87,    87,    87,    87,
      88,    88,    89,    89,    89,    89,    90,    90,    90,    90,
      90,    90,    91,    91,    91,    92,    92,    93,    93,    94,
      94,    95,    95,    96,    96,    96,    96,    96,    96,    96,
      96,    96,    96,    97,    98,    99,    99,   100,   100,   101,
     101,   101,   101,   101,   101,   101,   101,   102,   102,   103,
     103,   104,   104,   105,   105,   106,   106,   107,   108,   108,
     109,   109,   109,   109,   109,   109,   109,   109,   109,   109,
     109,   109,   109,   109,   109,   109,   110,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   111,   111,
     112,   112,   113,   113,   113,   113,   113,   113,   113,   113,
     113,   113,   114,   115,   115,   115,   115,   115,   115,   115,
     115,   115,   115,   115,   115,   116,   116,   116,   116,   116,
     116,   117,   117,   117,   117,   117,   118,   118,   118,   118,
     118,   118,   118,   118,   118,   118,   119,   119,   120,   120,
     121,   121,   122,   122,   122,   122,   123,   123,   123,   123,
     123,   124,   125,   126,   126,   127,   128,   128,   128,   128,
     128,   128,   128,   128,   128,   128,   129,   129,   129,   129
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     1,     2,     1,     1,     8,     8,     7,     7,
       6,     5,     3,     2,     3,     2,     1,     1,     1,     1,
       1,     1,     1,     3,     2,     2,     3,     2,     3,     2,
       1,     1,     3,     2,     1,     4,     5,     3,     2,     1,
       4,     5,     3,     2,     4,     1,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     1,     2,
       1,     2,     1,     2,     1,     2,     1,     1,     1,     2,
       2,     2,     2,     2,     3,     2,     1,     2,     1,     3,
       2,     1,     3,     3,     5,     5,     3,     3,     9,     9,
       4,     7,     5,     9,     5,     7,     9,    11,     2,     1,
       1,     1,     1,     3,     3,     3,     3,     3,     3,     2,
       1,     5,     2,     1,     1,     1,     4,     1,     1,     1,
       1,     1,     3,     7,    33,     1,     1,     1,     1,     1,
       1,     3,     3,     3,     3,     2,     3,     3,     3,     3,
       3,     6,     6,     6,     6,     6,     4,     3,     4,     3,
       1,     3,     6,     5,     5,     4,     1,     1,     1,     1,
       1,     1,     3,     2,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     6,     8,     6,     8
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       0,     0,     0,    49,    58,    50,    60,    64,    62,    51,
      66,    48,    47,    17,    18,    21,    20,    19,    16,     0,
       2,     4,     5,     0,     0,     0,     0,    30,    52,    53,
      54,    55,    56,    13,    15,    67,    57,    59,    63,    61,
      65,     1,     3,     0,     0,     0,    22,     0,     0,     0,
       0,     0,    29,     0,     0,     0,    24,    34,    39,    25,
      31,     0,     0,    12,    14,    26,     0,     0,     0,   169,
     167,   166,   170,   171,   172,   173,   174,   168,     0,   175,
       0,     0,     0,   101,   100,     0,     0,     0,     0,     0,
      81,    78,     0,     0,     0,    68,    76,     0,    99,     0,
       0,     0,     0,     0,     0,    23,     0,     0,    33,     0,
      38,     0,     0,     0,     0,     0,    13,     0,     0,     0,
       0,     0,    15,     0,     0,     0,   115,     0,   156,   157,
     158,   159,   160,     0,     0,     0,   165,   117,     0,     0,
     110,   102,     0,   121,   118,   119,   114,     0,   113,   120,
       0,     0,     0,     0,     0,     0,     0,     0,    80,     0,
      77,    34,    39,    27,    11,    69,    75,    98,    70,    71,
      72,     0,    73,     0,    43,    37,     0,    42,     0,    32,
       0,     0,     0,     0,   149,   150,     0,   136,   140,   139,
     138,   137,   147,     0,     0,    28,     0,     0,     0,   109,
       0,   135,     0,     0,   112,   125,   127,   130,   129,   128,
     126,     0,     0,     0,     0,     0,     0,    83,     0,     0,
       0,     0,    82,     0,    87,    86,     0,    74,     0,     0,
       0,     0,    79,     0,    10,    35,    40,     0,     0,     0,
       0,   148,     0,   146,     0,     0,   122,     0,   131,   107,
     108,   106,   104,   105,   103,     0,   132,     0,   134,   133,
       0,   161,     0,     0,     0,     0,     0,     0,    90,     0,
       0,     0,    36,    41,     8,     0,     9,     0,   151,     0,
       0,     0,     0,     0,   116,     0,    85,     0,    84,   155,
       0,     0,     0,     0,     0,     0,    92,     0,    94,     0,
       0,   115,     0,     0,     0,     6,     7,   141,   145,   144,
     143,   142,     0,   111,   163,     0,   154,     0,   153,     0,
       0,     0,     0,     0,     0,     0,   176,   178,     0,     0,
      45,     0,   162,   152,   164,     0,     0,     0,    95,     0,
      91,     0,     0,    44,     0,   123,     0,     0,     0,     0,
       0,     0,   177,   179,    46,     0,    89,    88,    93,    96,
       0,     0,     0,     0,    97,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   124
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short yydefgoto[] =
{
      -1,    19,    20,    21,    91,    23,    24,    45,    46,    92,
      93,    59,    60,   108,   272,   329,    26,   138,    28,    29,
      30,    31,    32,    36,    94,    95,    96,    97,    98,   185,
     140,   141,   218,   154,   143,   144,   145,   186,   146,   147,
     262,   292,   293,   148,   102,   149
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -119
static const short yypact[] =
{
    2133,   -33,   -28,  -119,   -17,  -119,   -17,   -17,   -17,  -119,
     -17,  -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,   971,
    -119,  -119,  -119,   102,    17,    80,   531,  -119,  -119,  -119,
    -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,
    -119,  -119,  -119,   461,    -9,   -16,  -119,   115,   -25,    -1,
      18,    29,  -119,   115,  1417,    28,   424,   -37,   -34,    14,
    -119,   326,   376,  -119,  -119,    14,    52,    83,   101,  -119,
    -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,   461,  -119,
    1681,  1681,   107,  -119,  -119,  1681,   110,   116,   118,   929,
    -119,  -119,   109,   152,   990,  -119,  -119,   113,   125,   122,
     124,   130,   139,   135,  1417,  -119,  1681,   -65,  -119,   -11,
    -119,   115,   138,    21,   146,    99,  1681,  1681,  1681,  1681,
    1681,  1681,  1681,  1681,   115,   143,   117,   149,  -119,  -119,
    -119,  -119,  -119,  1681,  1681,  1681,  -119,  -119,  1681,   785,
    -119,  -119,   870,  -119,  -119,  -119,  -119,   148,  -119,  -119,
     785,   870,  1681,  2016,   106,  1681,  1681,  1456,  -119,  1051,
    -119,   -46,   -35,    14,  -119,  -119,  -119,  -119,  -119,  -119,
    -119,  1681,  -119,  1112,  2187,  -119,   150,  -119,   159,  -119,
    1417,   154,  1417,   157,  -119,  2187,   -18,  2187,  2187,  2187,
    2187,  2187,  -119,    -7,   499,    14,  1531,  1606,  1681,  -119,
    2187,  -119,   972,    66,  -119,  -119,  -119,  -119,  -119,  -119,
    -119,  1681,  1681,  1681,  1681,  1681,  1681,   193,  1681,  1681,
    1681,  1681,   194,  1681,  -119,  -119,  2037,  -119,  1033,  1094,
    1417,  1338,  -119,  1443,  -119,   177,   177,  1173,  1417,  1234,
    1417,  -119,  1681,  -119,   145,   625,  -119,  1681,  -119,   180,
     180,   -63,   172,   172,  -119,  1417,  2187,  2175,   187,  -119,
    1417,  2187,   -50,  1681,  1417,  1681,  1417,  1681,  -119,  1681,
    1756,   174,  -119,  -119,  -119,  1295,  -119,  1356,  2187,  1681,
    1681,  1681,  1681,  1681,   145,  1518,  -119,  1681,  -119,  -119,
    1681,  1681,     5,     7,  2058,   -29,  -119,  1593,  -119,  1155,
     852,    92,   -42,  1668,  1681,  -119,  -119,  2187,  2187,  2187,
    2187,  2187,  1681,  2187,  2187,   690,  -119,    16,  -119,  1681,
    1681,  1681,  1681,  1417,  1681,  1417,  -119,  -119,   144,    48,
    2187,  1216,  -119,  -119,  2187,  2095,  2111,  2127,  -119,  1277,
    -119,   178,   179,  -119,  1681,  -119,  1681,  1417,  1417,  1417,
    1417,  1681,  -119,  -119,  2187,  1743,  -119,  -119,  -119,  -119,
    2143,  1681,  1417,  1774,  -119,  1681,  1796,  1681,  1818,  1681,
    1840,  1681,  1862,  1681,  1884,  1681,  1906,  1681,  1928,  1681,
    1950,  1681,  1972,  1681,  1994,  1681,  2159,  -119
};

/* YYPGOTO[NTERM-NUM].  */
static const short yypgoto[] =
{
    -119,  -119,   238,  -119,     3,  -119,  -119,   114,   203,  -119,
      15,   -43,   151,   -57,    25,  -119,  -119,     0,  -119,  -119,
    -119,  -119,  -119,   199,   -80,   510,  -119,  -119,  -119,   360,
    -119,  -119,  -119,   -68,   -52,   -19,   140,  -118,  -119,  -119,
    -119,  -119,   -27,   -54,  -119,   270
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const unsigned short yytable[] =
{
      27,   110,    99,    22,   193,   106,   214,   215,   216,   159,
      65,   136,   142,   151,   106,    25,   106,   106,   175,    27,
      48,    49,    22,    27,   173,   289,    52,   219,    63,   220,
     221,   290,   291,   327,    25,   100,   107,    99,    47,    64,
     198,    33,    99,    27,   167,   107,    34,   109,   109,    61,
     163,   321,    99,   176,    27,   178,    27,   241,    53,    55,
      35,    27,    27,   242,    56,   136,   201,   203,   243,    54,
     100,    47,   177,    62,   242,   100,    47,    47,    27,   193,
     316,   195,   318,    50,    51,   100,   290,    99,   319,    27,
      99,   333,    63,   124,    27,   111,   181,   319,    99,    99,
     237,    56,   239,    64,    27,   110,   104,    99,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    57,    58,
     100,    99,   219,   100,   220,   221,   116,   343,    99,   344,
      99,   100,   100,    43,   117,   118,   119,   120,   121,    27,
     100,   248,    27,   117,   118,   119,   120,   121,   341,   342,
      27,    27,   258,   259,   100,   161,   162,   122,   275,    27,
     277,   100,   219,   100,   220,   221,   197,   326,   117,   118,
     119,   120,   121,    27,   183,   113,   115,    44,    99,    56,
      27,   152,    27,   123,   155,    99,    99,    99,    99,   160,
     156,   197,   157,   166,   101,   295,   279,   280,   281,   282,
     283,   136,   168,    99,   169,    37,    38,    39,    99,    40,
     170,   100,    99,   171,    99,   172,   180,   196,   100,   100,
     100,   100,   223,    99,   182,    99,   255,   260,   271,   101,
      27,   198,   238,   235,   101,   240,   100,    27,    27,    27,
      27,   100,   236,   216,   101,   100,   221,   100,   213,   214,
     215,   216,   304,   352,   353,    27,   100,    42,   100,   105,
      27,   273,   179,     0,    27,   317,    27,     0,     0,     0,
       0,    99,     0,    99,     0,    27,     0,    27,     0,   101,
       0,     0,   101,     0,     0,     0,     0,     0,     0,     0,
     101,   101,     0,     0,     0,    99,    99,    99,    99,   101,
       0,     0,     0,     0,   100,     0,   100,     0,     0,     0,
      99,     0,     0,   101,     0,     0,     0,     0,     0,     0,
     101,     0,   101,    27,   103,    27,     0,     0,   100,   100,
     100,   100,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,     0,   100,     0,     0,     0,    27,    27,    27,
      27,     0,     0,     0,     0,     0,     0,    43,     0,   103,
       0,     0,    27,     0,   103,     0,     0,     0,     0,     0,
     101,     0,     0,     0,   103,     0,     0,   101,   101,   101,
     101,     0,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,     0,     0,     0,   101,     0,     0,     0,     0,
     101,   112,     0,     0,   101,     0,   101,    43,     0,   103,
       0,     0,   103,     0,     0,   101,     0,   101,     0,     0,
     103,   103,     0,     0,     0,     0,     0,     0,     0,   103,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
     139,   150,     0,   103,     0,   153,     0,     0,     0,     0,
     103,   114,   103,     0,     0,    43,     0,     0,     0,     0,
       0,     0,     0,   101,     0,   101,   174,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,   187,   188,   189,
     190,   191,     0,   194,     0,     0,     0,   101,   101,   101,
     101,     0,     0,   199,   200,   202,     0,     0,   204,     0,
     103,     0,   101,     0,     0,     0,     0,   103,   103,   103,
     103,     0,   226,     0,     0,   228,   229,   231,     0,     0,
       0,     0,     0,     0,     0,   103,     0,     0,     0,     0,
     103,   233,     0,     0,   103,     0,   103,     3,     4,     5,
       6,     7,     8,     9,    10,   103,     0,   103,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   245,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   249,   250,   251,   252,   253,   254,     0,   256,   257,
     200,   200,   244,   261,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   103,     0,   103,     0,     0,     0,     0,
       0,     0,   278,     0,   165,     0,     0,   285,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   103,   103,   103,
     103,     0,     0,   294,     0,   297,     0,   299,     0,   300,
     303,     0,   103,     0,     0,     0,     0,     0,     0,   307,
     308,   309,   310,   311,     0,     0,     0,   313,     0,   217,
     314,   315,   222,     0,     0,     0,     0,     0,     0,     0,
     224,   225,     0,     0,   330,     0,     0,     0,     0,   165,
       0,     0,   331,     0,     0,     0,     0,     0,     0,   334,
     335,   336,   337,   165,   339,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,     0,     0,     0,
       0,     0,     0,     0,   354,     0,   355,     0,   284,     0,
       0,   360,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   363,     0,     0,     0,   366,     0,   368,     0,   370,
       0,   372,     0,   374,     0,   376,     0,   378,     0,   380,
     268,   382,     0,   384,     0,   386,     0,   165,     0,   165,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,     0,     0,     0,   286,     0,     0,     0,     0,
     288,     0,     0,   332,   296,     0,   298,     0,     0,     0,
       0,     0,     0,     0,     0,   165,     0,   165,    66,    67,
      68,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    69,     0,     0,     0,    70,     0,    71,    72,    73,
      74,    75,    76,    77,    78,    79,     0,    80,     0,    81,
      82,    83,    84,    85,    86,    87,    88,     0,     0,     0,
       0,     0,     0,   338,     0,   340,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   356,   357,   358,
     359,     0,     0,    89,     0,    90,     0,     0,     0,     0,
       0,     0,   364,    66,    67,    68,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    69,     0,     0,     0,
      70,     0,    71,    72,    73,    74,    75,    76,    77,    78,
      79,     0,    80,     0,    81,    82,    83,    84,    85,    86,
      87,    88,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,     0,     0,   219,   325,   220,   221,
       0,     0,    66,    67,    68,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    69,     0,     0,    89,    70,
      90,    71,    72,    73,    74,    75,    76,    77,    78,    79,
       0,    80,     0,    81,    82,    83,    84,    85,    86,    87,
      88,    41,     0,     0,     1,     2,     0,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    66,    67,    68,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    69,    89,   158,    90,
      70,     0,    71,    72,    73,    74,    75,    76,    77,    78,
      79,     0,    80,     0,    81,    82,    83,    84,    85,    86,
      87,    88,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,     0,     0,     0,   246,     0,     0,
       0,     0,     0,   247,    66,    67,    68,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    69,    89,   164,
      90,    70,     0,    71,    72,    73,    74,    75,    76,    77,
      78,    79,     0,    80,     0,    81,    82,    83,    84,    85,
      86,    87,    88,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,     0,     0,     0,   264,     0,
       0,     0,     0,     0,   265,    66,    67,    68,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    69,    89,
     232,    90,    70,     0,    71,    72,    73,    74,    75,    76,
      77,    78,    79,     0,    80,     0,    81,    82,    83,    84,
      85,    86,    87,    88,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,     0,     0,     0,   266,
       0,     0,     0,     0,     0,   267,    66,    67,    68,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    69,
      89,   234,    90,    70,     0,    71,    72,    73,    74,    75,
      76,    77,    78,    79,     0,    80,     0,    81,    82,    83,
      84,    85,    86,    87,    88,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,     0,     0,     0,
     323,     0,     0,     0,     0,     0,   324,    66,    67,    68,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      69,    89,   274,    90,    70,     0,    71,    72,    73,    74,
      75,    76,    77,    78,    79,     0,    80,     0,    81,    82,
      83,    84,    85,    86,    87,    88,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,     0,     0,
       0,   345,     0,     0,     0,     0,     0,   346,    66,    67,
      68,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    69,    89,   276,    90,    70,     0,    71,    72,    73,
      74,    75,    76,    77,    78,    79,     0,    80,     0,    81,
      82,    83,    84,    85,    86,    87,    88,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,     0,
       0,     0,   350,     0,     0,     0,     0,     0,   351,    66,
      67,    68,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    69,    89,   305,    90,    70,     0,    71,    72,
      73,    74,    75,    76,    77,    78,    79,     0,    80,     0,
      81,    82,    83,    84,    85,    86,    87,    88,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   269,
      66,    67,    68,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    69,    89,   306,    90,    70,     0,    71,
      72,    73,    74,    75,    76,    77,    78,    79,     0,    80,
       0,    81,    82,    83,    84,    85,    86,    87,    88,   125,
     126,   127,     3,     4,     5,     6,     7,     8,     9,    10,
       0,     0,    69,     0,     0,     0,    70,     0,    71,    72,
      73,    74,    75,    76,    77,     0,    79,     0,     0,     0,
       0,     0,     0,     0,     0,    89,     0,    90,   128,   129,
     130,   131,   132,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,     0,     0,     0,     0,     0,
       0,     0,     0,   133,   270,     0,     0,     0,   134,     0,
     135,   230,   136,   137,   125,   126,   127,     3,     4,     5,
       6,     7,     8,     9,    10,     0,     0,    69,     0,     0,
       0,    70,     0,    71,    72,    73,    74,    75,    76,    77,
       0,    79,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   128,   129,   130,   131,   132,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
       0,     0,     0,     0,     0,     0,     0,     0,   133,   312,
       0,     0,     0,   134,     0,   135,   184,   136,   137,   125,
     126,   127,     3,     4,     5,     6,     7,     8,     9,    10,
       0,     0,    69,     0,     0,     0,    70,     0,    71,    72,
      73,    74,    75,    76,    77,     0,    79,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   128,   129,
     130,   131,   132,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,     0,     0,     0,     0,     0,
       0,     0,     0,   133,   322,     0,     0,     0,   134,     0,
     135,   192,   136,   137,   125,   126,   127,     3,     4,     5,
       6,     7,     8,     9,    10,     0,     0,    69,     0,     0,
       0,    70,     0,    71,    72,    73,    74,    75,    76,    77,
       0,    79,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   128,   129,   130,   131,   132,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
       0,     0,     0,     0,     0,     0,     0,     0,   133,   328,
       0,     0,     0,   134,     0,   135,     0,   136,   137,   125,
     301,   302,     3,     4,     5,     6,     7,     8,     9,    10,
       0,     0,    69,     0,     0,     0,    70,     0,    71,    72,
      73,    74,    75,    76,    77,     0,    79,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   128,   129,
     130,   131,   132,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,     0,     0,     0,     0,     0,
       0,     0,     0,   133,   361,     0,     0,     0,   134,     0,
     135,     0,   136,   137,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   365,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   367,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   369,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   371,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   373,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   375,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   377,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   379,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   381,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   383,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   385,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,     0,     0,
       0,     0,     0,     0,     0,     0,   227,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,     0,
       0,     0,     0,     0,     0,     0,     0,   263,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
       0,     0,     0,     0,     0,     0,     1,     2,   320,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,     0,     0,     0,
     347,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,     0,     0,     0,   348,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,     0,
       0,     0,   349,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,     0,     0,     0,   362,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,     0,   287,     0,   387,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216
};

static const short yycheck[] =
{
       0,    58,    54,     0,   122,    51,    69,    70,    71,    89,
      53,    76,    80,    81,    51,     0,    51,    51,    83,    19,
       3,     4,    19,    23,   104,    75,    26,    56,    74,    58,
      59,    81,    82,    75,    19,    54,    82,    89,    23,    74,
      82,    74,    94,    43,    98,    82,    74,    82,    82,    74,
      93,    80,   104,   107,    54,   109,    56,    75,    43,    75,
      77,    61,    62,    81,    80,    76,   134,   135,    75,    78,
      89,    56,    83,    74,    81,    94,    61,    62,    78,   197,
      75,   124,    75,     3,     4,   104,    81,   139,    81,    89,
     142,    75,    74,    78,    94,    81,    75,    81,   150,   151,
     180,    80,   182,    74,   104,   162,    78,   159,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,     3,     4,
     139,   173,    56,   142,    58,    59,    74,    79,   180,    81,
     182,   150,   151,    31,    51,    52,    53,    54,    55,   139,
     159,    75,   142,    51,    52,    53,    54,    55,     4,     5,
     150,   151,   220,   221,   173,     3,     4,    74,   238,   159,
     240,   180,    56,   182,    58,    59,    74,    75,    51,    52,
      53,    54,    55,   173,    75,    61,    62,    75,   230,    80,
     180,    74,   182,    82,    74,   237,   238,   239,   240,    80,
      74,    74,    74,    80,    54,   263,    51,    52,    53,    54,
      55,    76,    80,   255,    80,     6,     7,     8,   260,    10,
      80,   230,   264,    74,   266,    80,    78,    74,   237,   238,
     239,   240,    74,   275,    78,   277,    33,    33,    51,    89,
     230,    82,    78,    83,    94,    78,   255,   237,   238,   239,
     240,   260,    83,    71,   104,   264,    59,   266,    68,    69,
      70,    71,    78,    75,    75,   255,   275,    19,   277,    56,
     260,   236,   111,    -1,   264,   292,   266,    -1,    -1,    -1,
      -1,   323,    -1,   325,    -1,   275,    -1,   277,    -1,   139,
      -1,    -1,   142,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     150,   151,    -1,    -1,    -1,   347,   348,   349,   350,   159,
      -1,    -1,    -1,    -1,   323,    -1,   325,    -1,    -1,    -1,
     362,    -1,    -1,   173,    -1,    -1,    -1,    -1,    -1,    -1,
     180,    -1,   182,   323,    54,   325,    -1,    -1,   347,   348,
     349,   350,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    -1,   362,    -1,    -1,    -1,   347,   348,   349,
     350,    -1,    -1,    -1,    -1,    -1,    -1,    31,    -1,    89,
      -1,    -1,   362,    -1,    94,    -1,    -1,    -1,    -1,    -1,
     230,    -1,    -1,    -1,   104,    -1,    -1,   237,   238,   239,
     240,    -1,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    -1,    -1,    -1,   255,    -1,    -1,    -1,    -1,
     260,    75,    -1,    -1,   264,    -1,   266,    31,    -1,   139,
      -1,    -1,   142,    -1,    -1,   275,    -1,   277,    -1,    -1,
     150,   151,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   159,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      80,    81,    -1,   173,    -1,    85,    -1,    -1,    -1,    -1,
     180,    75,   182,    -1,    -1,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   323,    -1,   325,   106,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,   117,   118,   119,
     120,   121,    -1,   123,    -1,    -1,    -1,   347,   348,   349,
     350,    -1,    -1,   133,   134,   135,    -1,    -1,   138,    -1,
     230,    -1,   362,    -1,    -1,    -1,    -1,   237,   238,   239,
     240,    -1,   152,    -1,    -1,   155,   156,   157,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   255,    -1,    -1,    -1,    -1,
     260,   171,    -1,    -1,   264,    -1,   266,     6,     7,     8,
       9,    10,    11,    12,    13,   275,    -1,   277,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   198,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,   211,   212,   213,   214,   215,   216,    -1,   218,   219,
     220,   221,    83,   223,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   323,    -1,   325,    -1,    -1,    -1,    -1,
      -1,    -1,   242,    -1,    94,    -1,    -1,   247,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   347,   348,   349,
     350,    -1,    -1,   263,    -1,   265,    -1,   267,    -1,   269,
     270,    -1,   362,    -1,    -1,    -1,    -1,    -1,    -1,   279,
     280,   281,   282,   283,    -1,    -1,    -1,   287,    -1,   139,
     290,   291,   142,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     150,   151,    -1,    -1,   304,    -1,    -1,    -1,    -1,   159,
      -1,    -1,   312,    -1,    -1,    -1,    -1,    -1,    -1,   319,
     320,   321,   322,   173,   324,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   344,    -1,   346,    -1,    83,    -1,
      -1,   351,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   361,    -1,    -1,    -1,   365,    -1,   367,    -1,   369,
      -1,   371,    -1,   373,    -1,   375,    -1,   377,    -1,   379,
     230,   381,    -1,   383,    -1,   385,    -1,   237,    -1,   239,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    -1,    -1,    -1,   255,    -1,    -1,    -1,    -1,
     260,    -1,    -1,    83,   264,    -1,   266,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   275,    -1,   277,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    -1,    -1,    -1,    20,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    -1,    32,    -1,    34,
      35,    36,    37,    38,    39,    40,    41,    -1,    -1,    -1,
      -1,    -1,    -1,   323,    -1,   325,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,   347,   348,   349,
     350,    -1,    -1,    78,    -1,    80,    -1,    -1,    -1,    -1,
      -1,    -1,   362,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    -1,    -1,    -1,
      20,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    -1,    32,    -1,    34,    35,    36,    37,    38,    39,
      40,    41,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    -1,    -1,    56,    75,    58,    59,
      -1,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    -1,    -1,    78,    20,
      80,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      -1,    32,    -1,    34,    35,    36,    37,    38,    39,    40,
      41,     0,    -1,    -1,     3,     4,    -1,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    78,    79,    80,
      20,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    -1,    32,    -1,    34,    35,    36,    37,    38,    39,
      40,    41,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    -1,    -1,    -1,    75,    -1,    -1,
      -1,    -1,    -1,    81,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    78,    79,
      80,    20,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    -1,    32,    -1,    34,    35,    36,    37,    38,
      39,    40,    41,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    -1,    -1,    -1,    75,    -1,
      -1,    -1,    -1,    -1,    81,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    78,
      79,    80,    20,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    -1,    32,    -1,    34,    35,    36,    37,
      38,    39,    40,    41,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    -1,    -1,    -1,    75,
      -1,    -1,    -1,    -1,    -1,    81,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      78,    79,    80,    20,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    -1,    32,    -1,    34,    35,    36,
      37,    38,    39,    40,    41,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    -1,    -1,    -1,
      75,    -1,    -1,    -1,    -1,    -1,    81,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    78,    79,    80,    20,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    -1,    32,    -1,    34,    35,
      36,    37,    38,    39,    40,    41,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    -1,    -1,
      -1,    75,    -1,    -1,    -1,    -1,    -1,    81,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    78,    79,    80,    20,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    -1,    32,    -1,    34,
      35,    36,    37,    38,    39,    40,    41,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    -1,
      -1,    -1,    75,    -1,    -1,    -1,    -1,    -1,    81,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    78,    79,    80,    20,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    -1,    32,    -1,
      34,    35,    36,    37,    38,    39,    40,    41,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    81,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    78,    79,    80,    20,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    -1,    32,
      -1,    34,    35,    36,    37,    38,    39,    40,    41,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    -1,    16,    -1,    -1,    -1,    20,    -1,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    78,    -1,    80,    42,    43,
      44,    45,    46,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    67,    81,    -1,    -1,    -1,    72,    -1,
      74,    75,    76,    77,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    -1,    16,    -1,    -1,
      -1,    20,    -1,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    42,    43,    44,    45,    46,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    67,    81,
      -1,    -1,    -1,    72,    -1,    74,    75,    76,    77,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    -1,    16,    -1,    -1,    -1,    20,    -1,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    42,    43,
      44,    45,    46,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    67,    81,    -1,    -1,    -1,    72,    -1,
      74,    75,    76,    77,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    -1,    16,    -1,    -1,
      -1,    20,    -1,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    42,    43,    44,    45,    46,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    67,    81,
      -1,    -1,    -1,    72,    -1,    74,    -1,    76,    77,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    -1,    16,    -1,    -1,    -1,    20,    -1,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    42,    43,
      44,    45,    46,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    67,    81,    -1,    -1,    -1,    72,    -1,
      74,    -1,    76,    77,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    81,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    81,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    81,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    81,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    81,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    81,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    81,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    81,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    81,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    81,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    81,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    80,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    80,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      -1,    -1,    -1,    -1,    -1,    -1,     3,     4,    80,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    -1,    -1,    -1,
      75,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    -1,    -1,    -1,    75,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    -1,
      -1,    -1,    75,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    -1,    -1,    -1,    75,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    -1,    57,    -1,    75,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,     3,     4,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    85,
      86,    87,    88,    89,    90,    94,   100,   101,   102,   103,
     104,   105,   106,    74,    74,    77,   107,   107,   107,   107,
     107,     0,    86,    31,    75,    91,    92,    94,     3,     4,
       3,     4,   101,    94,    78,    75,    80,     3,     4,    95,
      96,    74,    74,    74,    74,    95,     3,     4,     5,    16,
      20,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      32,    34,    35,    36,    37,    38,    39,    40,    41,    78,
      80,    88,    93,    94,   108,   109,   110,   111,   112,   118,
     119,   120,   128,   129,    78,    92,    51,    82,    97,    82,
      97,    81,    75,    91,    75,    91,    74,    51,    52,    53,
      54,    55,    74,    82,    94,     3,     4,     5,    42,    43,
      44,    45,    46,    67,    72,    74,    76,    77,   101,   113,
     114,   115,   117,   118,   119,   120,   122,   123,   127,   129,
     113,   117,    74,   113,   117,    74,    74,    74,    79,   108,
      80,     3,     4,    95,    79,   109,    80,   127,    80,    80,
      80,    74,    80,   108,   113,    83,   127,    83,   127,    96,
      78,    75,    78,    75,    75,   113,   121,   113,   113,   113,
     113,   113,    75,   121,   113,    95,    74,    74,    82,   113,
     113,   117,   113,   117,   113,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,   109,   116,    56,
      58,    59,   109,    74,   109,   109,   113,    80,   113,   113,
      75,   113,    79,   113,    79,    83,    83,   108,    78,   108,
      78,    75,    81,    75,    83,   113,    75,    81,    75,   113,
     113,   113,   113,   113,   113,    33,   113,   113,   117,   117,
      33,   113,   124,    80,    75,    81,    75,    81,   109,    81,
      81,    51,    98,    98,    79,   108,    79,   108,   113,    51,
      52,    53,    54,    55,    83,   113,   109,    57,   109,    75,
      81,    82,   125,   126,   113,   117,   109,   113,   109,   113,
     113,     4,     5,   113,    78,    79,    79,   113,   113,   113,
     113,   113,    81,   113,   113,   113,    75,   126,    75,    81,
      80,    80,    81,    75,    81,    75,    75,    75,    81,    99,
     113,   113,    83,    75,   113,   113,   113,   113,   109,   113,
     109,     4,     5,    79,    81,    75,    81,    75,    75,    75,
      75,    81,    75,    75,   113,   113,   109,   109,   109,   109,
     113,    81,    75,   113,   109,    81,   113,    81,   113,    81,
     113,    81,   113,    81,   113,    81,   113,    81,   113,    81,
     113,    81,   113,    81,   113,    81,   113,    75
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrlab1


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)         \
  Current.first_line   = Rhs[1].first_line;      \
  Current.first_column = Rhs[1].first_column;    \
  Current.last_line    = Rhs[N].last_line;       \
  Current.last_column  = Rhs[N].last_column;
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (cinluded).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short *bottom, short *top)
#else
static void
yy_stack_print (bottom, top)
    short *bottom;
    short *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylineno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylineno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 167 "parser.yxx"
    {ParseTreePointer=yyvsp[0].m_pParseNode;}
    break;

  case 3:
#line 169 "parser.yxx"
    {ParseTreePointer->AddLastChild(yyvsp[0].m_pParseNode);}
    break;

  case 6:
#line 179 "parser.yxx"
    {
								// Store a pointer to the actual shader.
								yyval.m_pParseNode=new CqParseNodeShader(yyvsp[-6].m_Identifier->c_str(),yyvsp[-7].m_ShaderType);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[-1].m_pParseNode);

								// Now copy any initialisers from the formals list to their respective
								// local variable definitions.
								CqParseNode* pArgs=yyvsp[-4].m_pParseNode;
								ProcessShaderArguments( pArgs );
								yyval.m_pParseNode->AddLastChild( yyvsp[-4].m_pParseNode );
							}
    break;

  case 7:
#line 192 "parser.yxx"
    {
								// Store a pointer to the actual shader.
								CqString strName;
								if(yyvsp[-6].m_pSymbol.eType&1)	strName=CqVarDef::GetVariablePtr(yyvsp[-6].m_pSymbol.VarRef)->strName();
								else			strName=CqFuncDef::GetFunctionPtr(yyvsp[-6].m_pSymbol.FuncRef)->strName();
								yyval.m_pParseNode=new CqParseNodeShader(strName.c_str(),yyvsp[-7].m_ShaderType);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[-1].m_pParseNode);

								// Now copy any initialisers from the formals list to their respective
								// local variable definitions.
								CqParseNode* pArgs=yyvsp[-4].m_pParseNode;
								ProcessShaderArguments( pArgs );
								yyval.m_pParseNode->AddLastChild( yyvsp[-4].m_pParseNode );
							}
    break;

  case 8:
#line 208 "parser.yxx"
    {
								// Store a pointer to the actual shader.
								yyval.m_pParseNode=new CqParseNodeShader(yyvsp[-5].m_Identifier->c_str(), yyvsp[-6].m_ShaderType);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[-1].m_pParseNode);
							}
    break;

  case 9:
#line 215 "parser.yxx"
    {
								// Store a pointer to the actual shader.
								CqString strName;
								if(yyvsp[-5].m_pSymbol.eType&1)	strName=CqVarDef::GetVariablePtr(yyvsp[-5].m_pSymbol.VarRef)->strName();
								else			strName=CqFuncDef::GetFunctionPtr(yyvsp[-5].m_pSymbol.FuncRef)->strName();
								yyval.m_pParseNode=new CqParseNodeShader(strName.c_str(),yyvsp[-6].m_ShaderType);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[-1].m_pParseNode);
							}
    break;

  case 10:
#line 228 "parser.yxx"
    {
								CqParseNodeDeclaration* pDecl=static_cast<CqParseNodeDeclaration*>(yyvsp[-5].m_pParseNode);

								// If no return/or multiple returns, then this is not a valid function.
								if((pDecl->Type()!=Type_Void) &&
								   (FunctionReturnCountStack.size() <=0 ||
								    FunctionReturnCountStack.back() != 1))
									yyerror("Must have one return in function");
								
								// Make a string of the parameter types.
								CqParseNode* pArgs=yyvsp[-4].m_pParseNode;
								CqString strArgTypes("");
								if(pArgs)
								{
									// Each child of the variable_definitions is a CqParseNodeVariable
									CqParseNodeVariable* pVar=static_cast<CqParseNodeVariable*>(pArgs->pFirstChild());
									while(pVar)
									{
										// If storage is not specified, a function parameter defaults to varying.
										pVar->SetDefaultStorage(Type_Varying);
										// Get the type from the variable
										strArgTypes+=CqParseNode::TypeIdentifier(pVar->ResType());
										// TODO: Find out if local function arguments can have default values.
										// If so, they can be found as the child of pVar.
										pVar=static_cast<CqParseNodeVariable*>(pVar->pNext());
									}
								}

								// Add the function declaration to the list of local functions.
								CqFuncDef funcdef(pDecl->Type(), pDecl->strName(), pDecl->strName(), strArgTypes.c_str(), yyvsp[-1].m_pParseNode, pArgs);
								CqFuncDef::AddFunction(funcdef);
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								delete(pDecl);
								// Function level namespace is now defunct.
								ParseNameSpaceStack.erase(ParseNameSpaceStack.end()-1);
								FunctionReturnCountStack.erase(FunctionReturnCountStack.end()-1);
							}
    break;

  case 11:
#line 267 "parser.yxx"
    {
								CqParseNodeDeclaration* pDecl=static_cast<CqParseNodeDeclaration*>(yyvsp[-4].m_pParseNode);

								// If no return/or multiple returns, then this is not a valid function.
								if((pDecl->Type()!=Type_Void) &&
								   (FunctionReturnCountStack.size() <=0 ||
								    FunctionReturnCountStack.back() != 1))
									yyerror("Must have one return in function");

								// Add the function declaration to the list of local functions.
								CqFuncDef funcdef(pDecl->Type(), pDecl->strName(), pDecl->strName(), "", yyvsp[-1].m_pParseNode, 0);
								CqFuncDef::AddFunction(funcdef);
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								delete(pDecl);
								// Function level namespace is now defunct.
								ParseNameSpaceStack.erase(ParseNameSpaceStack.end()-1);
								FunctionReturnCountStack.erase(FunctionReturnCountStack.end()-1);
							}
    break;

  case 12:
#line 289 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeDeclaration((strNameSpace()+*yyvsp[-1].m_Identifier).c_str(),yyvsp[-2].m_TypeAndSpace.Type);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								// Store the name of the function being defined for use in variable namespacing.
								ParseNameSpaceStack.push_back(strNameSpace()+*yyvsp[-1].m_Identifier+"::");
								// Push a new level onto the FunctionReturnCountStack.
								FunctionReturnCountStack.push_back(0);
							}
    break;

  case 13:
#line 297 "parser.yxx"
    {	
								yyval.m_pParseNode=new CqParseNodeDeclaration((strNameSpace()+*yyvsp[-1].m_Identifier).c_str(),Type_Void);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								// Store the name of the function being defined for use in variable namespacing.
								ParseNameSpaceStack.push_back(strNameSpace()+*yyvsp[-1].m_Identifier+"::");
								// Push a new level onto the FunctionReturnCountStack.
								FunctionReturnCountStack.push_back(0);
							}
    break;

  case 14:
#line 305 "parser.yxx"
    {
								// TODO: Should warn about duplicate declarations.
								CqString strName(strNameSpace());
								if(yyvsp[-1].m_pSymbol.eType&1)	strName+=CqVarDef::GetVariablePtr(yyvsp[-1].m_pSymbol.VarRef)->strName();
								else			strName+=CqFuncDef::GetFunctionPtr(yyvsp[-1].m_pSymbol.FuncRef)->strName();

								yyval.m_pParseNode=new CqParseNodeDeclaration(strName.c_str(),yyvsp[-2].m_TypeAndSpace.Type);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								// Store the name of the function being defined for use in variable namespacing.
								ParseNameSpaceStack.push_back(strName+"::");
								// Push a new level onto the FunctionReturnCountStack.
								FunctionReturnCountStack.push_back(0);
							}
    break;

  case 15:
#line 318 "parser.yxx"
    {	
								// TODO: Should warn about duplicate declarations.
								CqString strName(strNameSpace());
								if(yyvsp[-1].m_pSymbol.eType&1)	strName+=CqVarDef::GetVariablePtr(yyvsp[-1].m_pSymbol.VarRef)->strName();
								else			strName+=CqFuncDef::GetFunctionPtr(yyvsp[-1].m_pSymbol.FuncRef)->strName();

								yyval.m_pParseNode=new CqParseNodeDeclaration(strName.c_str(),Type_Void);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								// Store the name of the function being defined for use in variable namespacing.
								ParseNameSpaceStack.push_back(strName+"::");
								// Push a new level onto the FunctionReturnCountStack.
								FunctionReturnCountStack.push_back(0);
							}
    break;

  case 16:
#line 334 "parser.yxx"
    { 
								yyval.m_ShaderType = Type_Lightsource;
							}
    break;

  case 17:
#line 337 "parser.yxx"
    { 
								yyval.m_ShaderType = Type_Surface;
							}
    break;

  case 18:
#line 340 "parser.yxx"
    { 
								yyval.m_ShaderType = Type_Volume;
							}
    break;

  case 19:
#line 343 "parser.yxx"
    { 
								yyval.m_ShaderType = Type_Displacement;
							}
    break;

  case 20:
#line 346 "parser.yxx"
    { 
								yyval.m_ShaderType = Type_Transformation;
							}
    break;

  case 21:
#line 349 "parser.yxx"
    { 
								yyval.m_ShaderType = Type_Imager;
							}
    break;

  case 22:
#line 356 "parser.yxx"
    {
								// Create a list header, and add the first entry to it.
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNodeVariable* pVarNode=static_cast<CqParseNodeVariable*>(yyvsp[0].m_pParseNode->pFirstChild());
								while(pVarNode!=0)
								{
									CqParseNodeVariable* pVarNext=static_cast<CqParseNodeVariable*>(pVarNode->pNext());
									yyval.m_pParseNode->AddLastChild(pVarNode);
									pVarNode=pVarNext;
								}
							}
    break;

  case 23:
#line 369 "parser.yxx"
    {
								// Add this one to the list.
								CqParseNodeVariable* pVarNode=static_cast<CqParseNodeVariable*>(yyvsp[0].m_pParseNode->pFirstChild());
								while(pVarNode!=0)
								{
									CqParseNodeVariable* pVarNext=static_cast<CqParseNodeVariable*>(pVarNode->pNext());
									yyval.m_pParseNode->AddLastChild(pVarNode);
									pVarNode=pVarNext;
								}
							}
    break;

  case 25:
#line 384 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNodeDeclaration* pDecl=static_cast<CqParseNodeDeclaration*>(yyvsp[0].m_pParseNode->pFirstChild());
								while(pDecl)
								{
									TqInt Type=(yyvsp[-1].m_TypeAndSpace.Type);
									
									SqVarRef var;
									TqBool fv=CqVarDef::FindVariable((strNameSpace()+pDecl->strName()).c_str(), var);
									if(fv)
									{
										CqVarDef* pVar=CqVarDef::GetVariablePtr(var);
										// Check if the declaration marked it as an arry
										if(pVar->Type()&Type_Array)
											Type=(TqInt)(Type|Type_Array);

										pVar->SetType(Type);
										// Create a variable node, in the case of local variable definition, these nodes will be removed, 
										// and only the intitialisers kept.
										// In the case of function parameters, the variables will be needed for type string construction.
										CqParseNode* pVarNode=new CqParseNodeVariable(var);
										pVarNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
										yyval.m_pParseNode->AddLastChild(pVarNode);

										// Copy any initialisers
										if(pDecl->pFirstChild())
										{
											if(Type&Type_Array)
											{
												CqParseNode* pArrayInit=new CqParseNode();

												CqParseNode* pInitList=pDecl->pFirstChild();
												CqParseNode* pInit=pInitList->pFirstChild();
												TqInt i=0;
												while(pInit!=0)
												{
													CqParseNode* pInit2=pInit->pNext();
													CqParseNodeAssignArray* pInitFunc=new CqParseNodeAssignArray(var);
													pInitFunc->NoDup();
													CqParseNodeFloatConst* pIndex=new CqParseNodeFloatConst(i);

													pInitFunc->AddLastChild(pInit);
													pInitFunc->AddLastChild(pIndex);
													pArrayInit->AddLastChild(pInitFunc);

													i++;
													pInit=pInit2;
												}
												pVarNode->AddLastChild(pArrayInit);
											}
											else
											{
												// Create an assign operator to initialise the variable.
												CqParseNode* pV=new CqParseNodeAssign(var);
												pV->SetPos(ParseLineNumber,ParseStreamName.c_str());
												pV->NoDup();
												pV->AddLastChild(pDecl->pFirstChild());

												pVarNode->AddLastChild(pV);
												pDecl->ClearChild();
											}
										}
									}

									CqParseNode* pTemp=pDecl;
									pDecl=static_cast<CqParseNodeDeclaration*>(pDecl->pNext());
									delete(pTemp);
								}
							}
    break;

  case 26:
#line 455 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNodeDeclaration* pDecl=static_cast<CqParseNodeDeclaration*>(yyvsp[0].m_pParseNode->pFirstChild());
								while(pDecl)
								{
									TqInt Type=(yyvsp[-1].m_TypeAndSpace.Type);
									
									SqVarRef var;
									TqBool fv=CqVarDef::FindVariable((strNameSpace()+pDecl->strName()).c_str(), var);
									if(fv)
									{
										CqVarDef* pVar=CqVarDef::GetVariablePtr(var);
										// Check if the declaration marked it as an arry
										if(pVar->Type()&Type_Array)
											Type=(TqInt)(Type|Type_Array);

										pVar->SetType(Type);
										// Create a variable node, in the case of local variable definition, these nodes will be removed, 
										// and only the intitialisers kept.
										// In the case of function parameters, the variables will be needed for type string construction.
										CqParseNodeVariable* pVarNode=new CqParseNodeVariable(var);
										pVarNode->SetOutput();
										pVarNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
										yyval.m_pParseNode->AddLastChild(pVarNode);

										// Copy any initialisers
										if(pDecl->pFirstChild())
										{
											if(Type&Type_Array)
											{
												CqParseNode* pArrayInit=new CqParseNode();

												CqParseNode* pInitList=pDecl->pFirstChild();
												CqParseNode* pInit=pInitList->pFirstChild();
												TqInt i=0;
												while(pInit!=0)
												{
													CqParseNode* pInit2=pInit->pNext();
													CqParseNodeAssignArray* pInitFunc=new CqParseNodeAssignArray(var);
													pInitFunc->NoDup();
													CqParseNodeFloatConst* pIndex=new CqParseNodeFloatConst(i);

													pInitFunc->AddLastChild(pInit);
													pInitFunc->AddLastChild(pIndex);
													pArrayInit->AddLastChild(pInitFunc);

													i++;
													pInit=pInit2;
												}
												pVarNode->AddLastChild(pArrayInit);
											}
											else
											{
												// Create an assign operator to initialise the variable.
												CqParseNode* pV=new CqParseNodeAssign(var);
												pV->SetPos(ParseLineNumber,ParseStreamName.c_str());
												pV->NoDup();
												pV->AddLastChild(pDecl->pFirstChild());

												pVarNode->AddLastChild(pV);
												pDecl->ClearChild();
											}
										}
									}

									CqParseNode* pTemp=pDecl;
									pDecl=static_cast<CqParseNodeDeclaration*>(pDecl->pNext());
									delete(pTemp);
								}
							}
    break;

  case 27:
#line 531 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNodeDeclaration* pDecl=static_cast<CqParseNodeDeclaration*>(yyvsp[0].m_pParseNode->pFirstChild());
								while(pDecl)
								{
									TqInt Type=(yyvsp[-1].m_TypeAndSpace.Type);
									
									SqVarRef var;
									TqBool fv=CqVarDef::FindVariable((strNameSpace()+pDecl->strName()).c_str(), var);
									if(fv)
									{
										CqVarDef* pVar=CqVarDef::GetVariablePtr(var);
										// Check if the declaration marked it as an arry
										if(pVar->Type()&Type_Array)
										{
											Type=(TqInt)(Type|Type_Array);
											if( pVar->ArrayLength() <= 0 )
												yyerror("Array length must be specified.");
										}

										pVar->SetType(Type);
										// Create a variable node, in the case of local variable definition, these nodes will be removed, 
										// and only the intitialisers kept.
										// In the case of function parameters, the variables will be needed for type string construction.
										CqParseNode* pVarNode=new CqParseNodeVariable(var);
										pVarNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
										yyval.m_pParseNode->AddLastChild(pVarNode);

										// Copy any initialisers
										if(pDecl->pFirstChild())
										{
											if(Type&Type_Array)
											{
												CqParseNode* pArrayInit=new CqParseNode();

												CqParseNode* pInitList=pDecl->pFirstChild();
												CqParseNode* pInit=pInitList->pFirstChild();
												TqInt i=0;
												while(pInit!=0)
												{
													CqParseNode* pInit2=pInit->pNext();
													CqParseNodeAssignArray* pInitFunc=new CqParseNodeAssignArray(var);
													pInitFunc->NoDup();
													CqParseNodeFloatConst* pIndex=new CqParseNodeFloatConst(i);

													pInitFunc->AddLastChild(pInit);
													pInitFunc->AddLastChild(pIndex);
													pArrayInit->AddLastChild(pInitFunc);

													i++;
													pInit=pInit2;
												}
												pVarNode->AddLastChild(pArrayInit);
											}
											else
											{
												// Create an assign operator to initialise the variable.
												CqParseNode* pV=new CqParseNodeAssign(var);
												pV->SetPos(ParseLineNumber,ParseStreamName.c_str());
												pV->NoDup();
												pV->AddLastChild(pDecl->pFirstChild());

												pVarNode->AddLastChild(pV);
												pDecl->ClearChild();
											}
										}
									}

									CqParseNode* pTemp=pDecl;
									pDecl=static_cast<CqParseNodeDeclaration*>(pDecl->pNext());
									delete(pTemp);
								}
							}
    break;

  case 28:
#line 606 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNodeDeclaration* pDecl=static_cast<CqParseNodeDeclaration*>(yyvsp[0].m_pParseNode->pFirstChild());
								while(pDecl)
								{
									SqVarRef varLocal, varExtern;
									TqBool fvl=CqVarDef::FindVariable((strNameSpace()+pDecl->strName()).c_str(), varLocal);

									// As this is an extern, we need to repeatedly check in the previous namespaces
									// until we find the variable they are referring to.
									TqBool fve=TqFalse;
									if(!ParseNameSpaceStack.empty())
									{
										std::vector<CqString>::reverse_iterator i=ParseNameSpaceStack.rbegin()+1;
										while(!fve && i!=ParseNameSpaceStack.rend())
										{
											CqString strNS=*i;
											fve=CqVarDef::FindVariable((strNS+pDecl->strName()).c_str(), varExtern);
											i++;
										}
									}
									if(!fve)
									{
										// If not found in the namespaces defined in the code, check the global namespace.
										fve=CqVarDef::FindStandardVariable(pDecl->strName(), varExtern);
									}

									// If we found a candidate...
									if(fve && fvl)
									{
										CqVarDef* pvarLocal=CqVarDef::GetVariablePtr(varLocal);
										CqVarDef* pvarExtern=CqVarDef::GetVariablePtr(varExtern);
										CqParseNode* pVarNode=new CqParseNodeVariable(varLocal);
										pvarLocal->SetExtern(TqTrue, varExtern);
										pvarLocal->SetType(pvarExtern->Type());
										pVarNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
										yyval.m_pParseNode->AddLastChild(pVarNode);
									}
									else
										yyerror("extern not found");

									CqParseNode* pTemp=pDecl;
									pDecl=static_cast<CqParseNodeDeclaration*>(pDecl->pNext());
									delete(pTemp);
								}
							}
    break;

  case 29:
#line 656 "parser.yxx"
    {
								yyval.m_TypeAndSpace.Type=(TqInt)(yyvsp[0].m_TypeAndSpace.Type|yyvsp[-1].m_VarType);
								yyval.m_TypeAndSpace.Space=yyvsp[0].m_TypeAndSpace.Space;
							}
    break;

  case 31:
#line 664 "parser.yxx"
    {
								// Create a list header and add the first element.
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 32:
#line 671 "parser.yxx"
    {
								// This one to the list.
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 33:
#line 678 "parser.yxx"
    {
								// Create a new variable declaration based on the specified name.
								yyval.m_pParseNode=new CqParseNodeDeclaration(yyvsp[-1].m_Identifier->c_str());
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqVarDef vardef(Type_Void, (strNameSpace()+*yyvsp[-1].m_Identifier).c_str());
								CqVarDef::AddVariable(vardef);
								// Add the initialiser as the first child of the declaration.
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 34:
#line 687 "parser.yxx"
    {
								// Create a new variable declaration based on the specified name.
								yyval.m_pParseNode=new CqParseNodeDeclaration(yyvsp[0].m_Identifier->c_str());
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqVarDef vardef(Type_Void, (strNameSpace()+*yyvsp[0].m_Identifier).c_str());
								CqVarDef::AddVariable(vardef);
							}
    break;

  case 35:
#line 694 "parser.yxx"
    {
								// Create a new variable declaration based on the specified name.
								yyval.m_pParseNode=new CqParseNodeDeclaration(yyvsp[-3].m_Identifier->c_str());
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqVarDef vardef(Type_Array, (strNameSpace()+*yyvsp[-3].m_Identifier).c_str(), static_cast<TqInt>(yyvsp[-1].m_FloatConst));
								CqVarDef::AddVariable(vardef);
							}
    break;

  case 36:
#line 702 "parser.yxx"
    {
								// Create a new variable declaration based on the specified name.
								yyval.m_pParseNode=new CqParseNodeDeclaration(yyvsp[-4].m_Identifier->c_str());
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqVarDef vardef(Type_Array, (strNameSpace()+*yyvsp[-4].m_Identifier).c_str(), static_cast<TqInt>(yyvsp[-2].m_FloatConst));
								CqVarDef::AddVariable(vardef);
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 37:
#line 710 "parser.yxx"
    {
								// Create a new variable declaration based on the specified name.
								yyval.m_pParseNode=new CqParseNodeDeclaration(yyvsp[-2].m_Identifier->c_str());
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqVarDef vardef(Type_Array, (strNameSpace()+*yyvsp[-2].m_Identifier).c_str(), 0);
								CqVarDef::AddVariable(vardef);
							}
    break;

  case 38:
#line 717 "parser.yxx"
    {
								// Create a new declaration based on the name.
								// TODO: Should warn about duplicate declarations.
								CqString strName("");
								if(yyvsp[-1].m_pSymbol.eType&1)	strName=CqVarDef::GetVariablePtr(yyvsp[-1].m_pSymbol.VarRef)->strName();
								else			strName=CqFuncDef::GetFunctionPtr(yyvsp[-1].m_pSymbol.FuncRef)->strName();

								yyval.m_pParseNode=new CqParseNodeDeclaration(strName.c_str());
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqVarDef vardef(Type_Void, (strNameSpace()+strName).c_str());
								CqVarDef::AddVariable(vardef);
								// Add the initialiser as the first child of the declaration.
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 39:
#line 731 "parser.yxx"
    {
								CqString strName("");
								if(yyvsp[0].m_pSymbol.eType&1)	strName=CqVarDef::GetVariablePtr(yyvsp[0].m_pSymbol.VarRef)->strName();
								else			strName=CqFuncDef::GetFunctionPtr(yyvsp[0].m_pSymbol.FuncRef)->strName();

								yyval.m_pParseNode=new CqParseNodeDeclaration(strName.c_str());
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqVarDef vardef(Type_Void, (strNameSpace()+strName).c_str());
								CqVarDef::AddVariable(vardef);
							}
    break;

  case 40:
#line 741 "parser.yxx"
    {
								CqString strName("");
								if(yyvsp[-3].m_pSymbol.eType&1)	strName=CqVarDef::GetVariablePtr(yyvsp[-3].m_pSymbol.VarRef)->strName();
								else			strName=CqFuncDef::GetFunctionPtr(yyvsp[-3].m_pSymbol.FuncRef)->strName();

								yyval.m_pParseNode=new CqParseNodeDeclaration(strName.c_str());
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqVarDef vardef(Type_Array, (strNameSpace()+strName).c_str(), static_cast<TqInt>(yyvsp[-1].m_FloatConst));
								CqVarDef::AddVariable(vardef);
							}
    break;

  case 41:
#line 752 "parser.yxx"
    {
								CqString strName("");
								if(yyvsp[-4].m_pSymbol.eType&1)	strName=CqVarDef::GetVariablePtr(yyvsp[-4].m_pSymbol.VarRef)->strName();
								else			strName=CqFuncDef::GetFunctionPtr(yyvsp[-4].m_pSymbol.FuncRef)->strName();

								yyval.m_pParseNode=new CqParseNodeDeclaration(strName.c_str());
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqVarDef vardef(Type_Array, (strNameSpace()+strName).c_str(), static_cast<TqInt>(yyvsp[-2].m_FloatConst));
								CqVarDef::AddVariable(vardef);
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 42:
#line 763 "parser.yxx"
    {
								CqString strName("");
								if(yyvsp[-2].m_pSymbol.eType&1)	strName=CqVarDef::GetVariablePtr(yyvsp[-2].m_pSymbol.VarRef)->strName();
								else			strName=CqFuncDef::GetFunctionPtr(yyvsp[-2].m_pSymbol.FuncRef)->strName();

								yyval.m_pParseNode=new CqParseNodeDeclaration(strName.c_str());
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqVarDef vardef(Type_Array, (strNameSpace()+strName).c_str(), 0);
								CqVarDef::AddVariable(vardef);
							}
    break;

  case 43:
#line 776 "parser.yxx"
    {
								yyval.m_pParseNode=yyvsp[0].m_pParseNode;
							}
    break;

  case 44:
#line 783 "parser.yxx"
    {
								CqParseNode* pArrayInit=new CqParseNode();
								CqParseNode* pInit=yyvsp[-1].m_pParseNode->pFirstChild();
								while(pInit)
								{
									CqParseNode* pInit2=pInit->pNext();
									pArrayInit->AddLastChild(pInit);
									pInit=pInit2;
								}
								yyval.m_pParseNode=pArrayInit;
							}
    break;

  case 45:
#line 797 "parser.yxx"
    {
								// Create a list header and add the first element.
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 46:
#line 804 "parser.yxx"
    {
								// This one to the list.
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 47:
#line 811 "parser.yxx"
    {	yyval.m_VarType=Type_Varying;	}
    break;

  case 48:
#line 812 "parser.yxx"
    {	yyval.m_VarType=Type_Uniform;	}
    break;

  case 49:
#line 816 "parser.yxx"
    {	
								yyval.m_TypeAndSpace.Type=Type_Float;		
								yyval.m_TypeAndSpace.Space=0;
							}
    break;

  case 50:
#line 820 "parser.yxx"
    {
								yyval.m_TypeAndSpace.Type=Type_String;	
								yyval.m_TypeAndSpace.Space=0;
							}
    break;

  case 51:
#line 824 "parser.yxx"
    {
								yyval.m_TypeAndSpace.Type=Type_Void;
								yyval.m_TypeAndSpace.Space=0;
							}
    break;

  case 57:
#line 836 "parser.yxx"
    {
								yyval.m_TypeAndSpace.Type=Type_Point;		
								yyval.m_TypeAndSpace.Space=yyvsp[0].m_Identifier;
							}
    break;

  case 58:
#line 840 "parser.yxx"
    {
								yyval.m_TypeAndSpace.Type=Type_Point;		
								yyval.m_TypeAndSpace.Space=0;
							}
    break;

  case 59:
#line 847 "parser.yxx"
    {
								yyval.m_TypeAndSpace.Type=Type_Color;		
								yyval.m_TypeAndSpace.Space=yyvsp[0].m_Identifier;
							}
    break;

  case 60:
#line 851 "parser.yxx"
    {
								yyval.m_TypeAndSpace.Type=Type_Color;		
								yyval.m_TypeAndSpace.Space=0;
							}
    break;

  case 61:
#line 858 "parser.yxx"
    {
								yyval.m_TypeAndSpace.Type=Type_Vector;		
								yyval.m_TypeAndSpace.Space=yyvsp[0].m_Identifier;
							}
    break;

  case 62:
#line 862 "parser.yxx"
    {
								yyval.m_TypeAndSpace.Type=Type_Vector;		
								yyval.m_TypeAndSpace.Space=0;
							}
    break;

  case 63:
#line 869 "parser.yxx"
    {
								yyval.m_TypeAndSpace.Type=Type_Normal;		
								yyval.m_TypeAndSpace.Space=yyvsp[0].m_Identifier;
							}
    break;

  case 64:
#line 873 "parser.yxx"
    {
								yyval.m_TypeAndSpace.Type=Type_Normal;		
								yyval.m_TypeAndSpace.Space=0;
							}
    break;

  case 65:
#line 880 "parser.yxx"
    {
								yyval.m_TypeAndSpace.Type=Type_Matrix;		
								yyval.m_TypeAndSpace.Space=yyvsp[0].m_Identifier;
							}
    break;

  case 66:
#line 884 "parser.yxx"
    {
								yyval.m_TypeAndSpace.Type=Type_Matrix;		
								yyval.m_TypeAndSpace.Space=0;
							}
    break;

  case 68:
#line 895 "parser.yxx"
    {
								// Create a list header and add the first element.
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddFirstChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 69:
#line 902 "parser.yxx"
    {
								// Add this one to the list.
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 70:
#line 909 "parser.yxx"
    {yyval.m_pParseNode->NoDup();}
    break;

  case 71:
#line 910 "parser.yxx"
    {
								if(yyval.m_pParseNode->ResType()!=Type_Void)
								{
									yyval.m_pParseNode=new CqParseNodeDrop();
									yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
									yyval.m_pParseNode->AddLastChild(yyvsp[-1].m_pParseNode);
								}
							}
    break;

  case 72:
#line 918 "parser.yxx"
    {
								if(yyval.m_pParseNode->ResType()!=Type_Void)
								{
									yyval.m_pParseNode=new CqParseNodeDrop();
									yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
									yyval.m_pParseNode->AddLastChild(yyvsp[-1].m_pParseNode);
								}
							}
    break;

  case 73:
#line 926 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeDrop();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[-1].m_pParseNode);
							}
    break;

  case 74:
#line 932 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[-1].m_pParseNode);
								// Increment the count of returns for the current function.
								if(FunctionReturnCountStack.size() > 0)
									FunctionReturnCountStack.back()++;
							}
    break;

  case 77:
#line 943 "parser.yxx"
    {
								// Remove the variable nodes from these leaving just the 
								// intialisation code.
								// Each child of the variable_definitions is a CqParseNodeVariable
								CqParseNodeVariable* pVar=static_cast<CqParseNodeVariable*>(yyvsp[-1].m_pParseNode->pFirstChild());
								while(pVar)
								{
									CqParseNodeVariable* pTemp=static_cast<CqParseNodeVariable*>(pVar->pNext());

									// If storage is not specified, local variable defaults to varying.
									pVar->SetDefaultStorage(Type_Varying);
									
									// Relink the initialisers, if any, after the variable.
									if(pVar->pFirstChild())
									{
										// Make sure that any change in the storage type is communicated to the initialiser
										pVar->pFirstChild()->UpdateStorageStatus();
										CqParseNode* pVarying=pVar->pFirstChild();
										pVarying->LinkAfter(pVar);
									}
									pVar->UnLink();
									delete(pVar);
									pVar=pTemp;
								}
							}
    break;

  case 79:
#line 969 "parser.yxx"
    {	yyval.m_pParseNode=yyvsp[-1].m_pParseNode;	}
    break;

  case 80:
#line 970 "parser.yxx"
    {	yyval.m_pParseNode=new CqParseNode(); }
    break;

  case 81:
#line 971 "parser.yxx"
    {	yyval.m_pParseNode=new CqParseNode(); }
    break;

  case 82:
#line 973 "parser.yxx"
    {
								CqParseNode* pNew=new CqParseNodeConditional();
								pNew->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pNew->AddLastChild(yyvsp[-1].m_pParseNode);
								pNew->AddLastChild(yyvsp[0].m_pParseNode);
								yyval.m_pParseNode=pNew;
							}
    break;

  case 83:
#line 980 "parser.yxx"
    {
								CqParseNode* relation=new CqParseNodeRelOp(Op_NE);
								relation->SetPos(ParseLineNumber,ParseStreamName.c_str());
								relation->AddFirstChild(yyvsp[-1].m_pParseNode);
								CqParseNode* pcomp=new CqParseNodeFloatConst(0);
								relation->AddLastChild(pcomp);

								CqParseNode* pNew=new CqParseNodeConditional();
								pNew->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pNew->AddLastChild(relation);
								pNew->AddLastChild(yyvsp[0].m_pParseNode);
								yyval.m_pParseNode=pNew;

							}
    break;

  case 84:
#line 995 "parser.yxx"
    {
								CqParseNode* pNew=new CqParseNodeConditional();
								pNew->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pNew->AddLastChild(yyvsp[-3].m_pParseNode);
								pNew->AddLastChild(yyvsp[-2].m_pParseNode);
								pNew->AddLastChild(yyvsp[0].m_pParseNode);
								yyval.m_pParseNode=pNew;
							}
    break;

  case 85:
#line 1003 "parser.yxx"
    {
								CqParseNode* relation=new CqParseNodeRelOp(Op_NE);
								relation->SetPos(ParseLineNumber,ParseStreamName.c_str());
								relation->AddFirstChild(yyvsp[-3].m_pParseNode);
								CqParseNode* pcomp=new CqParseNodeFloatConst(0);
								relation->AddLastChild(pcomp);
								CqParseNode* pNew=new CqParseNodeConditional();
								
								pNew->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pNew->AddLastChild(relation);
								pNew->AddLastChild(yyvsp[-2].m_pParseNode);
								pNew->AddLastChild(yyvsp[0].m_pParseNode);
								yyval.m_pParseNode=pNew;
							}
    break;

  case 86:
#line 1022 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeWhileConstruct();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[-1].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 87:
#line 1028 "parser.yxx"
    {
								CqParseNode* relation=new CqParseNodeRelOp(Op_NE);
								relation->SetPos(ParseLineNumber,ParseStreamName.c_str());
								relation->AddFirstChild(yyvsp[-1].m_pParseNode);
								CqParseNode* pcomp=new CqParseNodeFloatConst(0);
								relation->AddLastChild(pcomp);
								CqParseNode* pNew=new CqParseNodeConditional();

								yyval.m_pParseNode=new CqParseNodeWhileConstruct();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(relation);
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 88:
#line 1042 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[-6].m_pParseNode);
								CqParseNode* pW=new CqParseNodeWhileConstruct();
								pW->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(pW);
								pW->AddLastChild(yyvsp[-4].m_pParseNode);
								pW->AddLastChild(yyvsp[0].m_pParseNode);
								pW->AddLastChild(yyvsp[-2].m_pParseNode);
								// Make sure that any assigns in the two expressions don't dup
								yyvsp[-6].m_pParseNode->NoDup();
								yyvsp[-2].m_pParseNode->NoDup();
							}
    break;

  case 89:
#line 1057 "parser.yxx"
    {
								CqParseNode* relation=new CqParseNodeRelOp(Op_NE);
								relation->SetPos(ParseLineNumber,ParseStreamName.c_str());
								relation->AddFirstChild(yyvsp[-4].m_pParseNode);
								CqParseNode* pcomp=new CqParseNodeFloatConst(0);
								relation->AddLastChild(pcomp);

								CqParseNode* pNew=new CqParseNodeConditional();
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[-6].m_pParseNode);
								CqParseNode* pW=new CqParseNodeWhileConstruct();
								pW->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(pW);
								pW->AddLastChild(relation);
								pW->AddLastChild(yyvsp[0].m_pParseNode);
								pW->AddLastChild(yyvsp[-2].m_pParseNode);
								// Make sure that any assigns in the two expressions don't dup
								yyvsp[-6].m_pParseNode->NoDup();
								yyvsp[-2].m_pParseNode->NoDup();
							}
    break;

  case 90:
#line 1079 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeSolarConstruct();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 91:
#line 1085 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeSolarConstruct(TqTrue);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNode* pArg=new CqParseNode();
								pArg->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pArg->AddFirstChild(yyvsp[-4].m_pParseNode);
								pArg->AddFirstChild(yyvsp[-2].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(pArg);
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
								// Make sure that any assigns in the two expressions don't dup
								yyvsp[-4].m_pParseNode->NoDup();
								yyvsp[-2].m_pParseNode->NoDup();
							}
    break;

  case 92:
#line 1099 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeIlluminateConstruct();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[-2].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
								// Make sure that any assigns in the two expressions don't dup
								yyvsp[-2].m_pParseNode->NoDup();
							}
    break;

  case 93:
#line 1108 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeIlluminateConstruct(TqTrue);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNode* pArg=new CqParseNode();
								pArg->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pArg->AddFirstChild(yyvsp[-6].m_pParseNode);
								pArg->AddFirstChild(yyvsp[-4].m_pParseNode);
								pArg->AddFirstChild(yyvsp[-2].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(pArg);
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
								// Make sure that any assigns in the two expressions don't dup
								yyvsp[-6].m_pParseNode->NoDup();
								yyvsp[-4].m_pParseNode->NoDup();
								yyvsp[-2].m_pParseNode->NoDup();
							}
    break;

  case 94:
#line 1124 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeIlluminanceConstruct();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNode* pArg=new CqParseNode();
								pArg->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pArg->AddFirstChild(new CqParseNodeStringConst(""));	// [category]
								pArg->AddFirstChild(yyvsp[-2].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(pArg);
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
								// Make sure that any assigns in the two expressions don't dup
								yyvsp[-2].m_pParseNode->NoDup();
							}
    break;

  case 95:
#line 1137 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeIlluminanceConstruct();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNode* pArg=new CqParseNode();
								pArg->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pArg->AddFirstChild(yyvsp[-4].m_pParseNode);
								pArg->AddFirstChild(yyvsp[-2].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(pArg);
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
								// Make sure that any assigns in the two expressions don't dup
								yyvsp[-4].m_pParseNode->NoDup();
								yyvsp[-2].m_pParseNode->NoDup();
							}
    break;

  case 96:
#line 1151 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeIlluminanceConstruct(TqTrue);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNode* pArg=new CqParseNode();
								pArg->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pArg->AddFirstChild(new CqParseNodeStringConst(""));	// [category]
								pArg->AddFirstChild(yyvsp[-6].m_pParseNode);
								pArg->AddFirstChild(yyvsp[-4].m_pParseNode);
								pArg->AddFirstChild(yyvsp[-2].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(pArg);
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
								// Make sure that any assigns in the two expressions don't dup
								yyvsp[-6].m_pParseNode->NoDup();
								yyvsp[-4].m_pParseNode->NoDup();
								yyvsp[-2].m_pParseNode->NoDup();
							}
    break;

  case 97:
#line 1168 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeIlluminanceConstruct(TqTrue);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNode* pArg=new CqParseNode();
								pArg->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pArg->AddFirstChild(yyvsp[-8].m_pParseNode);
								pArg->AddFirstChild(yyvsp[-6].m_pParseNode);
								pArg->AddFirstChild(yyvsp[-4].m_pParseNode);
								pArg->AddFirstChild(yyvsp[-2].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(pArg);
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
								// Make sure that any assigns in the two expressions don't dup
								yyvsp[-8].m_pParseNode->NoDup();
								yyvsp[-6].m_pParseNode->NoDup();
								yyvsp[-4].m_pParseNode->NoDup();
								yyvsp[-2].m_pParseNode->NoDup();
							}
    break;

  case 100:
#line 1193 "parser.yxx"
    {	
								yyval.m_pParseNode=new CqParseNode();	
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
							}
    break;

  case 101:
#line 1197 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNode();	
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
							}
    break;

  case 103:
#line 1207 "parser.yxx"
    {
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator.", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pFunc->AddLastChild(yyvsp[-2].m_pParseNode);
								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode=pFunc;
							}
    break;

  case 104:
#line 1218 "parser.yxx"
    {
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator/", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pFunc->AddLastChild(yyvsp[-2].m_pParseNode);
								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode=pFunc;
							}
    break;

  case 105:
#line 1229 "parser.yxx"
    {
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator*", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pFunc->AddLastChild(yyvsp[-2].m_pParseNode);
								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode=pFunc;
							}
    break;

  case 106:
#line 1240 "parser.yxx"
    {
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator^", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pFunc->AddLastChild(yyvsp[-2].m_pParseNode);
								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode=pFunc;
							}
    break;

  case 107:
#line 1251 "parser.yxx"
    {
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator+", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pFunc->AddLastChild(yyvsp[-2].m_pParseNode);
								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode=pFunc;
							}
    break;

  case 108:
#line 1262 "parser.yxx"
    {
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator-", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pFunc->AddLastChild(yyvsp[-2].m_pParseNode);
								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode=pFunc;
							}
    break;

  case 109:
#line 1273 "parser.yxx"
    {
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operatorneg", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pFunc->AddFirstChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode=pFunc;
							}
    break;

  case 111:
#line 1284 "parser.yxx"
    {
								CqParseNode* pNew=new CqParseNodeQCond();
								pNew->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pNew->AddLastChild(yyvsp[-4].m_pParseNode);
								pNew->AddLastChild(yyvsp[-2].m_pParseNode);
								pNew->AddLastChild(yyvsp[0].m_pParseNode);
								yyval.m_pParseNode=pNew;
							}
    break;

  case 112:
#line 1296 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNode* pCast=new CqParseNodeCast(yyvsp[-1].m_TypeAndSpace.Type);
								pCast->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pCast->AddFirstChild(yyvsp[0].m_pParseNode);
								
								TqInt Type=(TqInt)(yyvsp[-1].m_TypeAndSpace.Type&Type_Mask);
								CqString* pSpace=yyvsp[-1].m_TypeAndSpace.Space;
								// Check if the type has a valid space associated
								if(pSpace!=0 && pSpace->compare("")!=0 && 
								  ((Type==Type_Point) ||
								   (Type==Type_Normal) ||
								   (Type==Type_Vector) ||
								   (Type==Type_Matrix) ||
								   (Type==Type_Color) ))
								{
									// Create a transform function.
									std::vector<SqFuncRef> funcTrans;
									CqString strTrans("transform");;
									if(Type==Type_Normal)	strTrans="ntransform";
									else if(Type==Type_Vector)	strTrans="vtransform";
									else if(Type==Type_Matrix)	strTrans="mtransform";
									else if(Type==Type_Color)	strTrans="ctransform";
									if(FindFunction(strTrans.c_str(), funcTrans))
									{
										yyval.m_pParseNode=new CqParseNodeFunctionCall(funcTrans);
										yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
									
										// And create a holder for the arguments.
										CqParseNode* pFromSpace=new CqParseNodeStringConst((*yyvsp[-1].m_TypeAndSpace.Space).c_str());
										CqParseNode* pToSpace;
										if(Type != Type_Color)	pToSpace = new CqParseNodeStringConst("current");
										else					pToSpace = new CqParseNodeStringConst("rgb");
										yyval.m_pParseNode->AddLastChild(pFromSpace);
										yyval.m_pParseNode->AddLastChild(pToSpace);
										yyval.m_pParseNode->AddLastChild(pCast);
									}
								}
								else
									yyval.m_pParseNode->AddFirstChild(pCast);
							}
    break;

  case 113:
#line 1342 "parser.yxx"
    {	
								yyval.m_pParseNode=new CqParseNodeFloatConst(yyvsp[0].m_FloatConst);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
							}
    break;

  case 115:
#line 1347 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeVariable(yyvsp[0].m_pSymbol.VarRef);	
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
							}
    break;

  case 116:
#line 1351 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeVariableArray(yyvsp[-3].m_pSymbol.VarRef);
								yyval.m_pParseNode->AddLastChild(yyvsp[-1].m_pParseNode);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
							}
    break;

  case 117:
#line 1356 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeStringConst(yyvsp[0].m_Identifier->c_str());
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
							}
    break;

  case 122:
#line 1364 "parser.yxx"
    {	
								yyval.m_pParseNode=yyvsp[-1].m_pParseNode;
							}
    break;

  case 123:
#line 1368 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeTriple();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[-5].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-3].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-1].m_pParseNode);
							}
    break;

  case 124:
#line 1376 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeHexTuple();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[-31].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-29].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-27].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-25].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-23].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-21].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-19].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-17].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-15].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-13].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-11].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-9].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-7].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-5].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-3].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-1].m_pParseNode);
							}
    break;

  case 125:
#line 1399 "parser.yxx"
    {	yyval.m_pParseNode=new CqParseNodeRelOp(Op_G);	}
    break;

  case 126:
#line 1400 "parser.yxx"
    {	yyval.m_pParseNode=new CqParseNodeRelOp(Op_GE);	}
    break;

  case 127:
#line 1401 "parser.yxx"
    {	yyval.m_pParseNode=new CqParseNodeRelOp(Op_L);	}
    break;

  case 128:
#line 1402 "parser.yxx"
    {	yyval.m_pParseNode=new CqParseNodeRelOp(Op_LE);	}
    break;

  case 129:
#line 1403 "parser.yxx"
    {	yyval.m_pParseNode=new CqParseNodeRelOp(Op_EQ);	}
    break;

  case 130:
#line 1404 "parser.yxx"
    {	yyval.m_pParseNode=new CqParseNodeRelOp(Op_NE);	}
    break;

  case 131:
#line 1408 "parser.yxx"
    {
								yyval.m_pParseNode=yyvsp[-1].m_pParseNode;
							}
    break;

  case 132:
#line 1412 "parser.yxx"
    {
								yyval.m_pParseNode=yyvsp[-1].m_pParseNode;
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddFirstChild(yyvsp[-2].m_pParseNode);
								yyval.m_pParseNode->AddFirstChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 133:
#line 1419 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeLogicalOp(Op_LogAnd);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddFirstChild(yyvsp[-2].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 134:
#line 1426 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeLogicalOp(Op_LogOr);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddFirstChild(yyvsp[-2].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 135:
#line 1432 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeUnaryOp(Op_LogicalNot);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 136:
#line 1441 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeAssign(yyvsp[-2].m_pSymbol.VarRef);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 137:
#line 1447 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeAssign(yyvsp[-2].m_pSymbol.VarRef);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator+", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pFunc->AddLastChild(new CqParseNodeVariable(yyvsp[-2].m_pSymbol.VarRef));
								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode->AddLastChild(pFunc);
							}
    break;

  case 138:
#line 1461 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeAssign(yyvsp[-2].m_pSymbol.VarRef);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator-", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pFunc->AddLastChild(new CqParseNodeVariable(yyvsp[-2].m_pSymbol.VarRef));
								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode->AddLastChild(pFunc);
							}
    break;

  case 139:
#line 1475 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeAssign(yyvsp[-2].m_pSymbol.VarRef);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator*", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pFunc->AddLastChild(new CqParseNodeVariable(yyvsp[-2].m_pSymbol.VarRef));
								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode->AddLastChild(pFunc);
							}
    break;

  case 140:
#line 1489 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeAssign(yyvsp[-2].m_pSymbol.VarRef);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator/", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pFunc->AddLastChild(new CqParseNodeVariable(yyvsp[-2].m_pSymbol.VarRef));
								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode->AddLastChild(pFunc);
							}
    break;

  case 141:
#line 1503 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeAssignArray(yyvsp[-5].m_pSymbol.VarRef);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-3].m_pParseNode);
							}
    break;

  case 142:
#line 1510 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeAssignArray(yyvsp[-5].m_pSymbol.VarRef);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator+", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNodeVariableArray* pVar=new CqParseNodeVariableArray(yyvsp[-5].m_pSymbol.VarRef);
								pVar->AddLastChild(yyvsp[-3].m_pParseNode->Clone());
								pFunc->AddLastChild(pVar);

								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode->AddLastChild(pFunc);
								yyval.m_pParseNode->AddLastChild(yyvsp[-3].m_pParseNode);
							}
    break;

  case 143:
#line 1528 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeAssignArray(yyvsp[-5].m_pSymbol.VarRef);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator-", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNodeVariableArray* pVar=new CqParseNodeVariableArray(yyvsp[-5].m_pSymbol.VarRef);
								pVar->AddLastChild(yyvsp[-3].m_pParseNode->Clone());
								pFunc->AddLastChild(pVar);

								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode->AddLastChild(pFunc);
								yyval.m_pParseNode->AddLastChild(yyvsp[-3].m_pParseNode);
							}
    break;

  case 144:
#line 1546 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeAssignArray(yyvsp[-5].m_pSymbol.VarRef);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator*", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNodeVariableArray* pVar=new CqParseNodeVariableArray(yyvsp[-5].m_pSymbol.VarRef);
								pVar->AddLastChild(yyvsp[-3].m_pParseNode->Clone());
								pFunc->AddLastChild(pVar);

								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode->AddLastChild(pFunc);
								yyval.m_pParseNode->AddLastChild(yyvsp[-3].m_pParseNode);
							}
    break;

  case 145:
#line 1564 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeAssignArray(yyvsp[-5].m_pSymbol.VarRef);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator/", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNodeVariableArray* pVar=new CqParseNodeVariableArray(yyvsp[-5].m_pSymbol.VarRef);
								pVar->AddLastChild(yyvsp[-3].m_pParseNode->Clone());
								pFunc->AddLastChild(pVar);

								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode->AddLastChild(pFunc);
								yyval.m_pParseNode->AddLastChild(yyvsp[-3].m_pParseNode);
							}
    break;

  case 146:
#line 1585 "parser.yxx"
    {
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction(CqFuncDef::GetFunctionPtr(yyvsp[-3].m_pSymbol.FuncRef)->strName(), func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								while(yyvsp[-1].m_pParseNode->pFirstChild()!=0)	pFunc->AddLastChild(yyvsp[-1].m_pParseNode->pFirstChild());

								yyval.m_pParseNode=pFunc;
							}
    break;

  case 147:
#line 1594 "parser.yxx"
    {
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction(CqFuncDef::GetFunctionPtr(yyvsp[-2].m_pSymbol.FuncRef)->strName(), func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());

								yyval.m_pParseNode=pFunc;
							}
    break;

  case 148:
#line 1606 "parser.yxx"
    {
								std::cerr << warning << "Unresolved function " << yyvsp[-3].m_Identifier->c_str() << " will be treated as a DSO at runtime" << std::endl;
								CqParseNode* pArgs=yyvsp[-1].m_pParseNode;
								CqString strArgTypes("");
								if(pArgs)
								{
									CqParseNode* pArg=static_cast<CqParseNode*>(pArgs->pFirstChild());
									while(pArg)
									{
										strArgTypes+=CqParseNode::TypeIdentifier(pArg->ResType());
										pArg=static_cast<CqParseNode*>(pArg->pNext());
									}
								};

								CqFuncDef func_spec(Type_Nil,yyvsp[-3].m_Identifier->c_str(),"unresolved",strArgTypes.c_str(), (CqParseNode*)NULL, pArgs);
								CqParseNodeUnresolvedCall* pUFunc=new CqParseNodeUnresolvedCall(func_spec);
								pUFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								while(yyvsp[-1].m_pParseNode->pFirstChild()!=0)	pUFunc->AddLastChild(yyvsp[-1].m_pParseNode->pFirstChild());

								yyval.m_pParseNode=pUFunc;
							}
    break;

  case 149:
#line 1628 "parser.yxx"
    {
								// Need to emit a warning.
								// This should in theory be the eaiest case to handle
								// since there are no arguments that might need casting
								// later.
								std::cerr << warning << "Unresolved function " << yyvsp[-2].m_Identifier->c_str() << " will be treated as a DSO at runtime" << std::endl;
								CqFuncDef func_spec(Type_Nil, yyvsp[-2].m_Identifier->c_str(), "unresolved","");
								CqParseNodeUnresolvedCall* pUFunc=new CqParseNodeUnresolvedCall(func_spec);
								pUFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());

								yyval.m_pParseNode=pUFunc;
							}
    break;

  case 150:
#line 1643 "parser.yxx"
    {
								// Create a list header, and add the first entry.
									yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 151:
#line 1650 "parser.yxx"
    {
								// Add this entry to the list.
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 152:
#line 1658 "parser.yxx"
    {	
								// Add the texture_filename as the first argument
								yyval.m_pParseNode->AddFirstChild(yyvsp[-3].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-2].m_pParseNode);
								// Add all texture_arguments as further arguments to the function.
								CqParseNode* pParam=yyvsp[-1].m_pParseNode->pFirstChild();
								while(pParam!=0)
								{
									CqParseNode* pTemp=pParam->pNext();
									yyval.m_pParseNode->AddLastChild(pParam);
									pParam=pTemp;
								}
							}
    break;

  case 153:
#line 1672 "parser.yxx"
    {	
								// Add the texture_filename as the first argument
								yyval.m_pParseNode->AddFirstChild(yyvsp[-2].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(new CqParseNodeFloatConst(0));
								// Add all texture_arguments as further arguments to the function.
								CqParseNode* pParam=yyvsp[-1].m_pParseNode->pFirstChild();
								while(pParam!=0)
								{
									CqParseNode* pTemp=pParam->pNext();
									yyval.m_pParseNode->AddLastChild(pParam);
									pParam=pTemp;
								}
							}
    break;

  case 154:
#line 1686 "parser.yxx"
    {	
								// Add the texture_filename as the first argument
								yyval.m_pParseNode->AddFirstChild(yyvsp[-2].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-1].m_pParseNode);
							}
    break;

  case 155:
#line 1692 "parser.yxx"
    {	
								// Add the texture_filename as the first argument
								yyval.m_pParseNode->AddFirstChild(yyvsp[-1].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(new CqParseNodeFloatConst(0));
							}
    break;

  case 156:
#line 1700 "parser.yxx"
    {
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("texture", func);
								yyval.m_pParseNode=new CqParseNodeFunctionCall(func);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
							}
    break;

  case 157:
#line 1706 "parser.yxx"
    {
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("environment", func);
								yyval.m_pParseNode=new CqParseNodeFunctionCall(func);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
							}
    break;

  case 158:
#line 1712 "parser.yxx"
    {
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("bump", func);
								yyval.m_pParseNode=new CqParseNodeFunctionCall(func);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
							}
    break;

  case 159:
#line 1718 "parser.yxx"
    {
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("shadow", func);
								yyval.m_pParseNode=new CqParseNodeFunctionCall(func);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
							}
    break;

  case 160:
#line 1724 "parser.yxx"
    {
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("occlusion", func);
								yyval.m_pParseNode=new CqParseNodeFunctionCall(func);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
							}
    break;

  case 161:
#line 1733 "parser.yxx"
    {	
								yyval.m_pParseNode=yyvsp[0].m_pParseNode;	
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
							}
    break;

  case 162:
#line 1740 "parser.yxx"
    {	yyval.m_pParseNode=yyvsp[-1].m_pParseNode; }
    break;

  case 163:
#line 1744 "parser.yxx"
    {
								// Create a list header and add the first entry.
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddFirstChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 164:
#line 1751 "parser.yxx"
    {
								// Add this entry to the list.
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 166:
#line 1764 "parser.yxx"
    {yyval.m_CommType=CommTypeAtmosphere;}
    break;

  case 167:
#line 1765 "parser.yxx"
    {yyval.m_CommType=CommTypeDisplacement;}
    break;

  case 168:
#line 1766 "parser.yxx"
    {yyval.m_CommType=CommTypeLightsource;}
    break;

  case 169:
#line 1767 "parser.yxx"
    {yyval.m_CommType=CommTypeSurface;}
    break;

  case 170:
#line 1768 "parser.yxx"
    {yyval.m_CommType=CommTypeAttribute;}
    break;

  case 171:
#line 1769 "parser.yxx"
    {yyval.m_CommType=CommTypeOption;}
    break;

  case 172:
#line 1770 "parser.yxx"
    {yyval.m_CommType=CommTypeRendererInfo;}
    break;

  case 173:
#line 1771 "parser.yxx"
    {yyval.m_CommType=CommTypeIncident;}
    break;

  case 174:
#line 1772 "parser.yxx"
    {yyval.m_CommType=CommTypeOpposite;}
    break;

  case 175:
#line 1773 "parser.yxx"
    {yyval.m_CommType=CommTypeTextureInfo;}
    break;

  case 176:
#line 1779 "parser.yxx"
    {
								CqVarDef* pVD=0;
								TqBool fError=TqFalse;
								
								if((yyvsp[-3].m_pParseNode->ResType()&Type_Mask)!=Type_String)	fError=TqTrue;

								// Get the variable, error if not a variable.
								if(yyvsp[-1].m_pSymbol.eType&1)	pVD=CqVarDef::GetVariablePtr(yyvsp[-1].m_pSymbol.VarRef);
								
								if(pVD!=0 && !fError)
								{
									yyval.m_pParseNode=new CqParseNodeCommFunction(yyvsp[-5].m_CommType, yyvsp[-1].m_pSymbol.VarRef);
									yyval.m_pParseNode->AddLastChild(yyvsp[-3].m_pParseNode);
								}
								else
								{
									yyerror("invalid variable reference");
									yyval.m_pParseNode=new CqParseNode();
								}
							}
    break;

  case 177:
#line 1801 "parser.yxx"
    {
								CqVarDef* pVD=0;
								TqBool fError=TqFalse;
								
                                if((yyvsp[-5].m_pParseNode->ResType()&Type_Mask)!=Type_String)	fError=TqTrue;

							    if((yyvsp[-3].m_pParseNode->ResType()&Type_Mask)!=Type_String)	fError=TqTrue;

								// Get the variable, error if not a variable.
								if(yyvsp[-1].m_pSymbol.eType&1)	pVD=CqVarDef::GetVariablePtr(yyvsp[-1].m_pSymbol.VarRef);
								
								if(pVD!=0 && !fError)
								{
                                    
	                                CqParseNode* pArgs=yyvsp[-5].m_pParseNode;
                                    CqParseNodeStringConst* pString = (CqParseNodeStringConst *) pArgs;
                                    CqString strArg("");
                                    strArg += pString->strValue();
								        
									yyval.m_pParseNode=new CqParseNodeCommFunction(yyvsp[-7].m_CommType, strArg, yyvsp[-1].m_pSymbol.VarRef);
								    yyval.m_pParseNode->AddLastChild(yyvsp[-3].m_pParseNode);
								}
								else
								{
									yyerror("invalid variable reference");
									yyval.m_pParseNode=new CqParseNode();
								}
							}
    break;

  case 178:
#line 1830 "parser.yxx"
    {
								CqVarDef* pVD=0;
								TqBool fError=TqFalse;
								
								if((yyvsp[-3].m_pParseNode->ResType()&Type_Mask)!=Type_String)	fError=TqTrue;

								// Get the variable, error if not a variable.
								if(yyvsp[-1].m_pSymbol.eType&1)	pVD=CqVarDef::GetVariablePtr(yyvsp[-1].m_pSymbol.VarRef);
								
								if(pVD!=0 && !fError)
								{
									yyval.m_pParseNode=new CqParseNodeCommFunction(yyvsp[-5].m_CommType, yyvsp[-1].m_pSymbol.VarRef);
									yyval.m_pParseNode->AddLastChild(yyvsp[-3].m_pParseNode);
								}
								else
								{
									yyerror("invalid variable reference");
									yyval.m_pParseNode=new CqParseNode();
								}
							}
    break;

  case 179:
#line 1852 "parser.yxx"
    {
								CqVarDef* pVD=0;
								TqBool fError=TqFalse;
								
                                if((yyvsp[-5].m_pParseNode->ResType()&Type_Mask)!=Type_String)	fError=TqTrue;

							    if((yyvsp[-3].m_pParseNode->ResType()&Type_Mask)!=Type_String)	fError=TqTrue;

								// Get the variable, error if not a variable.
								if(yyvsp[-1].m_pSymbol.eType&1)	pVD=CqVarDef::GetVariablePtr(yyvsp[-1].m_pSymbol.VarRef);
								
								if(pVD!=0 && !fError)
								{
                                    
	                                CqParseNode* pArgs=yyvsp[-5].m_pParseNode;
                                    CqParseNodeStringConst* pString = (CqParseNodeStringConst *) pArgs;
                                    CqString strArg("");
                                    strArg += pString->strValue();
								        
									yyval.m_pParseNode=new CqParseNodeCommFunction(yyvsp[-7].m_CommType, strArg, yyvsp[-1].m_pSymbol.VarRef);
								    yyval.m_pParseNode->AddLastChild(yyvsp[-3].m_pParseNode);
								}
								else
								{
									yyerror("invalid variable reference");
									yyval.m_pParseNode=new CqParseNode();
								}
							}
    break;


    }

/* Line 999 of yacc.c.  */
#line 3995 "y.tab.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("syntax error, unexpected ") + 1;
	  yysize += yystrlen (yytname[yytype]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* Return failure if at end of input.  */
      if (yychar == YYEOF)
        {
	  /* Pop the error token.  */
          YYPOPSTACK;
	  /* Pop the rest of the stack.  */
	  while (yyss < yyssp)
	    {
	      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
	      yydestruct (yystos[*yyssp], yyvsp);
	      YYPOPSTACK;
	    }
	  YYABORT;
        }

      YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
      yydestruct (yytoken, &yylval);
      yychar = YYEMPTY;

    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*----------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action.  |
`----------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp);
      yyvsp--;
      yystate = *--yyssp;

      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 1883 "parser.yxx"


namespace Aqsis
{

TqBool FindVariable(const char* name, SqVarRef& Ref)
{
	// First search in the current namespace, then in the global namespace.
	CqString strLocalVar(strNameSpace()+name);
	
	if(CqVarDef::FindVariable(strLocalVar.c_str(), Ref))	return(TqTrue);
	else	return(CqVarDef::FindVariable(name, Ref));

	
}


TqBool FindFunction(const char* name, std::vector<SqFuncRef>& Ref)
{
	// Search in the namespaces from local to global in order.
	CqString strNS(strNameSpace());
	
	do
	{
		CqString strLocalFunc(strNS+name);
		if(CqFuncDef::FindFunction(strLocalFunc.c_str(), Ref))
			return(TqTrue);

		// Extract the next namespace up.
		if( ( strNS.size() > 2 ) && ( strNS.substr( strNS.size()-2 ) == "::" ) )
		{
			strNS = strNS.substr( 0, strNS.size()-2 );
			strNS = strNS.substr(0, strNS.rfind("::")+strlen("::"));
		}

	}while( strNS.find_last_of("::") != std::string::npos );
	
	return(CqFuncDef::FindFunction(name, Ref));
}


void TypeCheck()
{
	// Typecheck any declared variables.
	TqUint i;
	for(i=0; i<gLocalVars.size(); i++)
	{
		if(gLocalVars[i].pDefValue()!=0)
			gLocalVars[i].pDefValue()->TypeCheck(CqParseNode::pAllTypes(), Type_Last-1);
	}

	// Typecheck any local functions.
	for(i=0; i<gLocalFuncs.size(); i++)
	{
		if(gLocalFuncs[i].pDef()!=0)
		{
//			TqInt RetType=gLocalFuncs[i].Type();
			gLocalFuncs[i].pDefNode()->TypeCheck(CqParseNode::pAllTypes(), Type_Last-1);
		}
	}

	if(ParseTreePointer)
		ParseTreePointer->TypeCheck(CqParseNode::pAllTypes(), Type_Last-1);
}


void Optimise()
{
	// Optimise any local functions.
	TqUint i;
	for(i=0; i<gLocalFuncs.size(); i++)
	{
		if(gLocalFuncs[i].pDef()!=0)
			gLocalFuncs[i].pDefNode()->Optimise();
	}

	if(ParseTreePointer)
		ParseTreePointer->Optimise();
}


CqString strNameSpace()	
{
	CqString strRes("");

	if(!ParseNameSpaceStack.empty())
		strRes=ParseNameSpaceStack.back();

	return(strRes);
}

void InitStandardNamespace()
{
	ParseNameSpaceStack.push_back("");
}

void ProcessShaderArguments( CqParseNode* pArgs )
{
	if(pArgs)
	{
		// Each child of the variable_definitions is a CqParseNodeVariable
		CqParseNodeVariable* pVar=static_cast<CqParseNodeVariable*>(pArgs->pFirstChild());

		while(pVar)
		{
			// If storage is not specified, a shader parameter defaults to uniform.
			pVar->SetDefaultStorage(Type_Uniform);
			// Force the variable to be a parameter.
			pVar->SetParam();

			// Check if a default value has been specified.
			CqParseNode* pDefValue=pVar->pFirstChild();
			if(pDefValue!=0)
			{
				// Get a pointer to the local variable.
				CqVarDef* pVarDef=CqVarDef::GetVariablePtr(pVar->VarRef());
				if(pVarDef!=0)
				{
					CqParseNode Node;
					pDefValue->UnLink();
					CqParseNodeCast* pCast=new CqParseNodeCast(pVarDef->Type());
					Node.AddLastChild(pCast);
					pCast->AddLastChild(pDefValue);
					Node.Optimise();
					pVarDef->SetpDefValue(Node.pFirstChild());
					pVar->AddFirstChild( Node.pFirstChild() );
				}
			}
			pVar=static_cast<CqParseNodeVariable*>(pVar->pNext());
		}
	}
}


} // End Namespace

static void yyerror(const CqString Message)
{
	ParseSucceeded = false;
	//(*ParseErrorStream) << "libslparse > parser > error: " << Message.c_str() << " at " << ParseStreamName.c_str() << " line " << ParseLineNumber << std::endl;
	CqString strErr( ParseStreamName.c_str() );
	strErr += " : ";
	strErr += ParseLineNumber;
	strErr += " : ";
	strErr += Message.c_str();
	throw( strErr );
}

